﻿using Adaptation.Shared;
using Adaptation.Shared.Metrology;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.Json;

namespace Adaptation.Helpers
{

    public partial class ProcessData
    {

        public class FileRead
        {

            public class Description : IProcessDataDescription
            {

                public int Test { get; set; }
                public int Count { get; set; }
                public int Index { get; set; }
                //
                public string EventName { get; set; }
                public string NullData { get; set; }
                public string JobID { get; set; }
                public string Sequence { get; set; }
                public string MesEntity { get; set; }
                public string ReportFullPath { get; set; }
                public string ProcessJobID { get; set; }
                public string MID { get; set; }
                //
                public string Date { get; set; }
                public string Employee { get; set; }
                public string Lot { get; set; }
                public string PSN { get; set; }
                public string Reactor { get; set; }
                public string Recipe { get; set; }
                //
                public string Grade { get; set; }
                public string HeaderUniqueId { get; set; }
                public string RDS { get; set; }
                public string Session { get; set; }
                public string Side { get; set; }
                public string SrcDest { get; set; }
                public string UniqueId { get; set; }
                public string WaferID { get; set; }
                //
                public string DcnAllMax { get; set; }
                public string DcnAllMean { get; set; }
                public string DcnAllMin { get; set; }
                public string DcnAllStdDev { get; set; }
                public string DcnAreaCountMax { get; set; }
                public string DcnAreaCountMean { get; set; }
                public string DcnAreaCountMin { get; set; }
                public string DcnAreaCountStdDev { get; set; }
                public string DcnAreaMax { get; set; }
                public string DcnAreaMean { get; set; }
                public string DcnAreaMin { get; set; }
                public string DcnAreaStdDev { get; set; }
                public string DcnBin1Max { get; set; }
                public string DcnBin1Mean { get; set; }
                public string DcnBin1Min { get; set; }
                public string DcnBin1StdDev { get; set; }
                public string DcnBin2Max { get; set; }
                public string DcnBin2Mean { get; set; }
                public string DcnBin2Min { get; set; }
                public string DcnBin2StdDev { get; set; }
                public string DcnBin3Max { get; set; }
                public string DcnBin3Mean { get; set; }
                public string DcnBin3Min { get; set; }
                public string DcnBin3StdDev { get; set; }
                public string DcnBin4Max { get; set; }
                public string DcnBin4Mean { get; set; }
                public string DcnBin4Min { get; set; }
                public string DcnBin4StdDev { get; set; }
                public string DcnBin5Max { get; set; }
                public string DcnBin5Mean { get; set; }
                public string DcnBin5Min { get; set; }
                public string DcnBin5StdDev { get; set; }
                public string DcnBin6Max { get; set; }
                public string DcnBin6Mean { get; set; }
                public string DcnBin6Min { get; set; }
                public string DcnBin6StdDev { get; set; }
                public string DcnBin7Max { get; set; }
                public string DcnBin7Mean { get; set; }
                public string DcnBin7Min { get; set; }
                public string DcnBin7StdDev { get; set; }
                public string DcnBin8Max { get; set; }
                public string DcnBin8Mean { get; set; }
                public string DcnBin8Min { get; set; }
                public string DcnBin8StdDev { get; set; }
                public string DcnHazeAvgMax { get; set; }
                public string DcnHazeAvgMean { get; set; }
                public string DcnHazeAvgMin { get; set; }
                public string DcnHazeAvgStdDev { get; set; }
                public string DcnHazeMedianMax { get; set; }
                public string DcnHazeMedianMean { get; set; }
                public string DcnHazeMedianMin { get; set; }
                public string DcnHazeMedianStdDev { get; set; }
                public string DcnHazeStdDevMax { get; set; }
                public string DcnHazeStdDevMean { get; set; }
                public string DcnHazeStdDevMin { get; set; }
                public string DcnHazeStdDevStdDev { get; set; }
                public string DcnLpdESMax { get; set; }
                public string DcnLpdESMean { get; set; }
                public string DcnLpdESMin { get; set; }
                public string DcnLpdESStdDev { get; set; }
                public string DcnLpdMax { get; set; }
                public string DcnLpdMean { get; set; }
                public string DcnLpdMin { get; set; }
                public string DcnLpdNMax { get; set; }
                public string DcnLpdNMean { get; set; }
                public string DcnLpdNMin { get; set; }
                public string DcnLpdNStdDev { get; set; }
                public string DcnLpdStdDev { get; set; }
                public string DcnMicroScrMax { get; set; }
                public string DcnMicroScrMean { get; set; }
                public string DcnMicroScrMin { get; set; }
                public string DcnMicroScrStdDev { get; set; }
                public string DcnScrMax { get; set; }
                public string DcnScrMean { get; set; }
                public string DcnScrMin { get; set; }
                public string DcnScrStdDev { get; set; }
                public string DcnSlipMax { get; set; }
                public string DcnSlipMean { get; set; }
                public string DcnSlipMin { get; set; }
                public string DcnSlipStdDev { get; set; }
                public string DnnAllMax { get; set; }
                public string DnnAllMean { get; set; }
                public string DnnAllMin { get; set; }
                public string DnnAllStdDev { get; set; }
                public string DnnAreaCountMax { get; set; }
                public string DnnAreaCountMean { get; set; }
                public string DnnAreaCountMin { get; set; }
                public string DnnAreaCountStdDev { get; set; }
                public string DnnAreaMax { get; set; }
                public string DnnAreaMean { get; set; }
                public string DnnAreaMin { get; set; }
                public string DnnAreaStdDev { get; set; }
                public string DnnBin1Max { get; set; }
                public string DnnBin1Mean { get; set; }
                public string DnnBin1Min { get; set; }
                public string DnnBin1StdDev { get; set; }
                public string DnnBin2Max { get; set; }
                public string DnnBin2Mean { get; set; }
                public string DnnBin2Min { get; set; }
                public string DnnBin2StdDev { get; set; }
                public string DnnBin3Max { get; set; }
                public string DnnBin3Mean { get; set; }
                public string DnnBin3Min { get; set; }
                public string DnnBin3StdDev { get; set; }
                public string DnnBin4Max { get; set; }
                public string DnnBin4Mean { get; set; }
                public string DnnBin4Min { get; set; }
                public string DnnBin4StdDev { get; set; }
                public string DnnBin5Max { get; set; }
                public string DnnBin5Mean { get; set; }
                public string DnnBin5Min { get; set; }
                public string DnnBin5StdDev { get; set; }
                public string DnnBin6Max { get; set; }
                public string DnnBin6Mean { get; set; }
                public string DnnBin6Min { get; set; }
                public string DnnBin6StdDev { get; set; }
                public string DnnBin7Max { get; set; }
                public string DnnBin7Mean { get; set; }
                public string DnnBin7Min { get; set; }
                public string DnnBin7StdDev { get; set; }
                public string DnnBin8Max { get; set; }
                public string DnnBin8Mean { get; set; }
                public string DnnBin8Min { get; set; }
                public string DnnBin8StdDev { get; set; }
                public string DnnHazeAvgMax { get; set; }
                public string DnnHazeAvgMean { get; set; }
                public string DnnHazeAvgMin { get; set; }
                public string DnnHazeAvgStdDev { get; set; }
                public string DnnHazeMedianMax { get; set; }
                public string DnnHazeMedianMean { get; set; }
                public string DnnHazeMedianMin { get; set; }
                public string DnnHazeMedianStdDev { get; set; }
                public string DnnHazeStdDevMax { get; set; }
                public string DnnHazeStdDevMean { get; set; }
                public string DnnHazeStdDevMin { get; set; }
                public string DnnHazeStdDevStdDev { get; set; }
                public string DnnLpdESMax { get; set; }
                public string DnnLpdESMean { get; set; }
                public string DnnLpdESMin { get; set; }
                public string DnnLpdESStdDev { get; set; }
                public string DnnLpdMax { get; set; }
                public string DnnLpdMean { get; set; }
                public string DnnLpdMin { get; set; }
                public string DnnLpdNMax { get; set; }
                public string DnnLpdNMean { get; set; }
                public string DnnLpdNMin { get; set; }
                public string DnnLpdNStdDev { get; set; }
                public string DnnLpdStdDev { get; set; }
                public string DnnMicroScrMax { get; set; }
                public string DnnMicroScrMean { get; set; }
                public string DnnMicroScrMin { get; set; }
                public string DnnMicroScrStdDev { get; set; }
                public string DnnScrMax { get; set; }
                public string DnnScrMean { get; set; }
                public string DnnScrMin { get; set; }
                public string DnnScrStdDev { get; set; }
                public string DnnSlipMax { get; set; }
                public string DnnSlipMean { get; set; }
                public string DnnSlipMin { get; set; }
                public string DnnSlipStdDev { get; set; }
                public string DwnAllMax { get; set; }
                public string DwnAllMean { get; set; }
                public string DwnAllMin { get; set; }
                public string DwnAllStdDev { get; set; }
                public string DwnAreaCountMax { get; set; }
                public string DwnAreaCountMean { get; set; }
                public string DwnAreaCountMin { get; set; }
                public string DwnAreaCountStdDev { get; set; }
                public string DwnAreaMax { get; set; }
                public string DwnAreaMean { get; set; }
                public string DwnAreaMin { get; set; }
                public string DwnAreaStdDev { get; set; }
                public string DwnBin1Max { get; set; }
                public string DwnBin1Mean { get; set; }
                public string DwnBin1Min { get; set; }
                public string DwnBin1StdDev { get; set; }
                public string DwnBin2Max { get; set; }
                public string DwnBin2Mean { get; set; }
                public string DwnBin2Min { get; set; }
                public string DwnBin2StdDev { get; set; }
                public string DwnBin3Max { get; set; }
                public string DwnBin3Mean { get; set; }
                public string DwnBin3Min { get; set; }
                public string DwnBin3StdDev { get; set; }
                public string DwnBin4Max { get; set; }
                public string DwnBin4Mean { get; set; }
                public string DwnBin4Min { get; set; }
                public string DwnBin4StdDev { get; set; }
                public string DwnBin5Max { get; set; }
                public string DwnBin5Mean { get; set; }
                public string DwnBin5Min { get; set; }
                public string DwnBin5StdDev { get; set; }
                public string DwnBin6Max { get; set; }
                public string DwnBin6Mean { get; set; }
                public string DwnBin6Min { get; set; }
                public string DwnBin6StdDev { get; set; }
                public string DwnBin7Max { get; set; }
                public string DwnBin7Mean { get; set; }
                public string DwnBin7Min { get; set; }
                public string DwnBin7StdDev { get; set; }
                public string DwnBin8Max { get; set; }
                public string DwnBin8Mean { get; set; }
                public string DwnBin8Min { get; set; }
                public string DwnBin8StdDev { get; set; }
                public string DwnHazeAvgMax { get; set; }
                public string DwnHazeAvgMean { get; set; }
                public string DwnHazeAvgMin { get; set; }
                public string DwnHazeAvgStdDev { get; set; }
                public string DwnHazeMedianMax { get; set; }
                public string DwnHazeMedianMean { get; set; }
                public string DwnHazeMedianMin { get; set; }
                public string DwnHazeMedianStdDev { get; set; }
                public string DwnHazeStdDevMax { get; set; }
                public string DwnHazeStdDevMean { get; set; }
                public string DwnHazeStdDevMin { get; set; }
                public string DwnHazeStdDevStdDev { get; set; }
                public string DwnLpdESMax { get; set; }
                public string DwnLpdESMean { get; set; }
                public string DwnLpdESMin { get; set; }
                public string DwnLpdESStdDev { get; set; }
                public string DwnLpdMax { get; set; }
                public string DwnLpdMean { get; set; }
                public string DwnLpdMin { get; set; }
                public string DwnLpdNMax { get; set; }
                public string DwnLpdNMean { get; set; }
                public string DwnLpdNMin { get; set; }
                public string DwnLpdNStdDev { get; set; }
                public string DwnLpdStdDev { get; set; }
                public string DwnMicroScrMax { get; set; }
                public string DwnMicroScrMean { get; set; }
                public string DwnMicroScrMin { get; set; }
                public string DwnMicroScrStdDev { get; set; }
                public string DwnScrMax { get; set; }
                public string DwnScrMean { get; set; }
                public string DwnScrMin { get; set; }
                public string DwnScrStdDev { get; set; }
                public string DwnSlipMax { get; set; }
                public string DwnSlipMean { get; set; }
                public string DwnSlipMin { get; set; }
                public string DwnSlipStdDev { get; set; }
                public string DcnAll { get; set; }
                public string DcnArea { get; set; }
                public string DcnAreaCount { get; set; }
                public string DcnBin1 { get; set; }
                public string DcnBin2 { get; set; }
                public string DcnBin3 { get; set; }
                public string DcnBin4 { get; set; }
                public string DcnBin5 { get; set; }
                public string DcnBin6 { get; set; }
                public string DcnBin7 { get; set; }
                public string DcnBin8 { get; set; }
                public string DcnHazeAvg { get; set; }
                public string DcnHazeMedian { get; set; }
                public string DcnHazeStdDev { get; set; }
                public string DcnLpd { get; set; }
                public string DcnLpdES { get; set; }
                public string DcnLpdN { get; set; }
                public string DcnMicroScr { get; set; }
                public string DcnScr { get; set; }
                public string DcnSlip { get; set; }
                public string DnnAll { get; set; }
                public string DnnArea { get; set; }
                public string DnnAreaCount { get; set; }
                public string DnnBin1 { get; set; }
                public string DnnBin2 { get; set; }
                public string DnnBin3 { get; set; }
                public string DnnBin4 { get; set; }
                public string DnnBin5 { get; set; }
                public string DnnBin6 { get; set; }
                public string DnnBin7 { get; set; }
                public string DnnBin8 { get; set; }
                public string DnnHazeAvg { get; set; }
                public string DnnHazeMedian { get; set; }
                public string DnnHazeStdDev { get; set; }
                public string DnnLpd { get; set; }
                public string DnnLpdES { get; set; }
                public string DnnLpdN { get; set; }
                public string DnnMicroScr { get; set; }
                public string DnnScr { get; set; }
                public string DnnSlip { get; set; }
                public string DwnAll { get; set; }
                public string DwnArea { get; set; }
                public string DwnAreaCount { get; set; }
                public string DwnBin1 { get; set; }
                public string DwnBin2 { get; set; }
                public string DwnBin3 { get; set; }
                public string DwnBin4 { get; set; }
                public string DwnBin5 { get; set; }
                public string DwnBin6 { get; set; }
                public string DwnBin7 { get; set; }
                public string DwnBin8 { get; set; }
                public string DwnHazeAvg { get; set; }
                public string DwnHazeMedian { get; set; }
                public string DwnHazeStdDev { get; set; }
                public string DwnLpd { get; set; }
                public string DwnLpdES { get; set; }
                public string DwnLpdN { get; set; }
                public string DwnMicroScr { get; set; }
                public string DwnScr { get; set; }
                public string DwnSlip { get; set; }

                public string GetEventDescription() { return "File Has been read and parsed"; }

                public List<string> GetHeaderNames(ILogic logic, ConfigDataBase configDataBase)
                {
                    List<string> results = new List<string>
                    {
                        nameof(Date),
                        nameof(Employee),
                        nameof(Lot),
                        nameof(PSN),
                        nameof(Reactor),
                        nameof(Recipe)
                    };
                    return results;
                }

                public List<string> GetDetailNames(ILogic logic, ConfigDataBase configDataBase)
                {
                    List<string> results = new List<string>
                    {
                        nameof(Grade),
                        nameof(HeaderUniqueId),
                        nameof(RDS),
                        nameof(Session),
                        nameof(Side),
                        nameof(SrcDest),
                        nameof(UniqueId),
                        nameof(WaferID)
                    };
                    return results;
                }

                public List<string> GetParameterNames(ILogic logic, ConfigDataBase configDataBase)
                {
                    List<string> results = new List<string>
                    {
                        nameof(DcnAllMax),
                        nameof(DcnAllMean),
                        nameof(DcnAllMin),
                        nameof(DcnAllStdDev),
                        nameof(DcnAreaCountMax),
                        nameof(DcnAreaCountMean),
                        nameof(DcnAreaCountMin),
                        nameof(DcnAreaCountStdDev),
                        nameof(DcnAreaMax),
                        nameof(DcnAreaMean),
                        nameof(DcnAreaMin),
                        nameof(DcnAreaStdDev),
                        nameof(DcnBin1Max),
                        nameof(DcnBin1Mean),
                        nameof(DcnBin1Min),
                        nameof(DcnBin1StdDev),
                        nameof(DcnBin2Max),
                        nameof(DcnBin2Mean),
                        nameof(DcnBin2Min),
                        nameof(DcnBin2StdDev),
                        nameof(DcnBin3Max),
                        nameof(DcnBin3Mean),
                        nameof(DcnBin3Min),
                        nameof(DcnBin3StdDev),
                        nameof(DcnBin4Max),
                        nameof(DcnBin4Mean),
                        nameof(DcnBin4Min),
                        nameof(DcnBin4StdDev),
                        nameof(DcnBin5Max),
                        nameof(DcnBin5Mean),
                        nameof(DcnBin5Min),
                        nameof(DcnBin5StdDev),
                        nameof(DcnBin6Max),
                        nameof(DcnBin6Mean),
                        nameof(DcnBin6Min),
                        nameof(DcnBin6StdDev),
                        nameof(DcnBin7Max),
                        nameof(DcnBin7Mean),
                        nameof(DcnBin7Min),
                        nameof(DcnBin7StdDev),
                        nameof(DcnBin8Max),
                        nameof(DcnBin8Mean),
                        nameof(DcnBin8Min),
                        nameof(DcnBin8StdDev),
                        nameof(DcnHazeAvgMax),
                        nameof(DcnHazeAvgMean),
                        nameof(DcnHazeAvgMin),
                        nameof(DcnHazeAvgStdDev),
                        nameof(DcnHazeMedianMax),
                        nameof(DcnHazeMedianMean),
                        nameof(DcnHazeMedianMin),
                        nameof(DcnHazeMedianStdDev),
                        nameof(DcnHazeStdDevMax),
                        nameof(DcnHazeStdDevMean),
                        nameof(DcnHazeStdDevMin),
                        nameof(DcnHazeStdDevStdDev),
                        nameof(DcnLpdESMax),
                        nameof(DcnLpdESMean),
                        nameof(DcnLpdESMin),
                        nameof(DcnLpdESStdDev),
                        nameof(DcnLpdMax),
                        nameof(DcnLpdMean),
                        nameof(DcnLpdMin),
                        nameof(DcnLpdNMax),
                        nameof(DcnLpdNMean),
                        nameof(DcnLpdNMin),
                        nameof(DcnLpdNStdDev),
                        nameof(DcnLpdStdDev),
                        nameof(DcnMicroScrMax),
                        nameof(DcnMicroScrMean),
                        nameof(DcnMicroScrMin),
                        nameof(DcnMicroScrStdDev),
                        nameof(DcnScrMax),
                        nameof(DcnScrMean),
                        nameof(DcnScrMin),
                        nameof(DcnScrStdDev),
                        nameof(DcnSlipMax),
                        nameof(DcnSlipMean),
                        nameof(DcnSlipMin),
                        nameof(DcnSlipStdDev),
                        nameof(DnnAllMax),
                        nameof(DnnAllMean),
                        nameof(DnnAllMin),
                        nameof(DnnAllStdDev),
                        nameof(DnnAreaCountMax),
                        nameof(DnnAreaCountMean),
                        nameof(DnnAreaCountMin),
                        nameof(DnnAreaCountStdDev),
                        nameof(DnnAreaMax),
                        nameof(DnnAreaMean),
                        nameof(DnnAreaMin),
                        nameof(DnnAreaStdDev),
                        nameof(DnnBin1Max),
                        nameof(DnnBin1Mean),
                        nameof(DnnBin1Min),
                        nameof(DnnBin1StdDev),
                        nameof(DnnBin2Max),
                        nameof(DnnBin2Mean),
                        nameof(DnnBin2Min),
                        nameof(DnnBin2StdDev),
                        nameof(DnnBin3Max),
                        nameof(DnnBin3Mean),
                        nameof(DnnBin3Min),
                        nameof(DnnBin3StdDev),
                        nameof(DnnBin4Max),
                        nameof(DnnBin4Mean),
                        nameof(DnnBin4Min),
                        nameof(DnnBin4StdDev),
                        nameof(DnnBin5Max),
                        nameof(DnnBin5Mean),
                        nameof(DnnBin5Min),
                        nameof(DnnBin5StdDev),
                        nameof(DnnBin6Max),
                        nameof(DnnBin6Mean),
                        nameof(DnnBin6Min),
                        nameof(DnnBin6StdDev),
                        nameof(DnnBin7Max),
                        nameof(DnnBin7Mean),
                        nameof(DnnBin7Min),
                        nameof(DnnBin7StdDev),
                        nameof(DnnBin8Max),
                        nameof(DnnBin8Mean),
                        nameof(DnnBin8Min),
                        nameof(DnnBin8StdDev),
                        nameof(DnnHazeAvgMax),
                        nameof(DnnHazeAvgMean),
                        nameof(DnnHazeAvgMin),
                        nameof(DnnHazeAvgStdDev),
                        nameof(DnnHazeMedianMax),
                        nameof(DnnHazeMedianMean),
                        nameof(DnnHazeMedianMin),
                        nameof(DnnHazeMedianStdDev),
                        nameof(DnnHazeStdDevMax),
                        nameof(DnnHazeStdDevMean),
                        nameof(DnnHazeStdDevMin),
                        nameof(DnnHazeStdDevStdDev),
                        nameof(DnnLpdESMax),
                        nameof(DnnLpdESMean),
                        nameof(DnnLpdESMin),
                        nameof(DnnLpdESStdDev),
                        nameof(DnnLpdMax),
                        nameof(DnnLpdMean),
                        nameof(DnnLpdMin),
                        nameof(DnnLpdNMax),
                        nameof(DnnLpdNMean),
                        nameof(DnnLpdNMin),
                        nameof(DnnLpdNStdDev),
                        nameof(DnnLpdStdDev),
                        nameof(DnnMicroScrMax),
                        nameof(DnnMicroScrMean),
                        nameof(DnnMicroScrMin),
                        nameof(DnnMicroScrStdDev),
                        nameof(DnnScrMax),
                        nameof(DnnScrMean),
                        nameof(DnnScrMin),
                        nameof(DnnScrStdDev),
                        nameof(DnnSlipMax),
                        nameof(DnnSlipMean),
                        nameof(DnnSlipMin),
                        nameof(DnnSlipStdDev),
                        nameof(DwnAllMax),
                        nameof(DwnAllMean),
                        nameof(DwnAllMin),
                        nameof(DwnAllStdDev),
                        nameof(DwnAreaCountMax),
                        nameof(DwnAreaCountMean),
                        nameof(DwnAreaCountMin),
                        nameof(DwnAreaCountStdDev),
                        nameof(DwnAreaMax),
                        nameof(DwnAreaMean),
                        nameof(DwnAreaMin),
                        nameof(DwnAreaStdDev),
                        nameof(DwnBin1Max),
                        nameof(DwnBin1Mean),
                        nameof(DwnBin1Min),
                        nameof(DwnBin1StdDev),
                        nameof(DwnBin2Max),
                        nameof(DwnBin2Mean),
                        nameof(DwnBin2Min),
                        nameof(DwnBin2StdDev),
                        nameof(DwnBin3Max),
                        nameof(DwnBin3Mean),
                        nameof(DwnBin3Min),
                        nameof(DwnBin3StdDev),
                        nameof(DwnBin4Max),
                        nameof(DwnBin4Mean),
                        nameof(DwnBin4Min),
                        nameof(DwnBin4StdDev),
                        nameof(DwnBin5Max),
                        nameof(DwnBin5Mean),
                        nameof(DwnBin5Min),
                        nameof(DwnBin5StdDev),
                        nameof(DwnBin6Max),
                        nameof(DwnBin6Mean),
                        nameof(DwnBin6Min),
                        nameof(DwnBin6StdDev),
                        nameof(DwnBin7Max),
                        nameof(DwnBin7Mean),
                        nameof(DwnBin7Min),
                        nameof(DwnBin7StdDev),
                        nameof(DwnBin8Max),
                        nameof(DwnBin8Mean),
                        nameof(DwnBin8Min),
                        nameof(DwnBin8StdDev),
                        nameof(DwnHazeAvgMax),
                        nameof(DwnHazeAvgMean),
                        nameof(DwnHazeAvgMin),
                        nameof(DwnHazeAvgStdDev),
                        nameof(DwnHazeMedianMax),
                        nameof(DwnHazeMedianMean),
                        nameof(DwnHazeMedianMin),
                        nameof(DwnHazeMedianStdDev),
                        nameof(DwnHazeStdDevMax),
                        nameof(DwnHazeStdDevMean),
                        nameof(DwnHazeStdDevMin),
                        nameof(DwnHazeStdDevStdDev),
                        nameof(DwnLpdESMax),
                        nameof(DwnLpdESMean),
                        nameof(DwnLpdESMin),
                        nameof(DwnLpdESStdDev),
                        nameof(DwnLpdMax),
                        nameof(DwnLpdMean),
                        nameof(DwnLpdMin),
                        nameof(DwnLpdNMax),
                        nameof(DwnLpdNMean),
                        nameof(DwnLpdNMin),
                        nameof(DwnLpdNStdDev),
                        nameof(DwnLpdStdDev),
                        nameof(DwnMicroScrMax),
                        nameof(DwnMicroScrMean),
                        nameof(DwnMicroScrMin),
                        nameof(DwnMicroScrStdDev),
                        nameof(DwnScrMax),
                        nameof(DwnScrMean),
                        nameof(DwnScrMin),
                        nameof(DwnScrStdDev),
                        nameof(DwnSlipMax),
                        nameof(DwnSlipMean),
                        nameof(DwnSlipMin),
                        nameof(DwnSlipStdDev),
                        nameof(DcnAll),
                        nameof(DcnArea),
                        nameof(DcnAreaCount),
                        nameof(DcnBin1),
                        nameof(DcnBin2),
                        nameof(DcnBin3),
                        nameof(DcnBin4),
                        nameof(DcnBin5),
                        nameof(DcnBin6),
                        nameof(DcnBin7),
                        nameof(DcnBin8),
                        nameof(DcnHazeAvg),
                        nameof(DcnHazeMedian),
                        nameof(DcnHazeStdDev),
                        nameof(DcnLpd),
                        nameof(DcnLpdES),
                        nameof(DcnLpdN),
                        nameof(DcnMicroScr),
                        nameof(DcnScr),
                        nameof(DcnSlip),
                        nameof(DnnAll),
                        nameof(DnnArea),
                        nameof(DnnAreaCount),
                        nameof(DnnBin1),
                        nameof(DnnBin2),
                        nameof(DnnBin3),
                        nameof(DnnBin4),
                        nameof(DnnBin5),
                        nameof(DnnBin6),
                        nameof(DnnBin7),
                        nameof(DnnBin8),
                        nameof(DnnHazeAvg),
                        nameof(DnnHazeMedian),
                        nameof(DnnHazeStdDev),
                        nameof(DnnLpd),
                        nameof(DnnLpdES),
                        nameof(DnnLpdN),
                        nameof(DnnMicroScr),
                        nameof(DnnScr),
                        nameof(DnnSlip),
                        nameof(DwnAll),
                        nameof(DwnArea),
                        nameof(DwnAreaCount),
                        nameof(DwnBin1),
                        nameof(DwnBin2),
                        nameof(DwnBin3),
                        nameof(DwnBin4),
                        nameof(DwnBin5),
                        nameof(DwnBin6),
                        nameof(DwnBin7),
                        nameof(DwnBin8),
                        nameof(DwnHazeAvg),
                        nameof(DwnHazeMedian),
                        nameof(DwnHazeStdDev),
                        nameof(DwnLpd),
                        nameof(DwnLpdES),
                        nameof(DwnLpdN),
                        nameof(DwnMicroScr),
                        nameof(DwnScr),
                        nameof(DwnSlip)
                    };
                    return results;
                }

                public List<string> GetPairedParameterNames(ILogic logic, ConfigDataBase configDataBase)
                {
                    List<string> results = new List<string>();
                    return results;
                }

                public List<string> GetIgnoreParameterNames(ILogic logic, ConfigDataBase configDataBase, Test test)
                {
                    List<string> results = new List<string>();
                    return results;
                }

                public List<string> GetNames(ILogic logic, ConfigDataBase configDataBase)
                {
                    List<string> results = new List<string>();
                    IProcessDataDescription processDataDescription = GetDefault(logic, configDataBase);
                    string json = JsonSerializer.Serialize(processDataDescription, processDataDescription.GetType());
                    object @object = JsonSerializer.Deserialize<object>(json);
                    if (!(@object is JsonElement jsonElement))
                        throw new Exception();
                    foreach (JsonProperty jsonProperty in jsonElement.EnumerateObject())
                        results.Add(jsonProperty.Name);
                    return results;
                }

                public IProcessDataDescription GetDisplayNames(ILogic logic, ConfigDataBase configDataBase)
                {
                    Description result = new Description();
                    return result;
                }

                public IProcessDataDescription GetDefault(ILogic logic, ConfigDataBase configDataBase)
                {
                    Description result = new Description
                    {
                        Test = -1,
                        Count = 0,
                        Index = -1,
                        //
                        EventName = configDataBase.GetEventName(),
                        NullData = string.Empty,
                        JobID = logic.Logistics.JobID,
                        Sequence = logic.Logistics.Sequence.ToString(),
                        MesEntity = logic.Logistics.MesEntity,
                        ReportFullPath = logic.Logistics.ReportFullPath,
                        ProcessJobID = logic.Logistics.ProcessJobID,
                        MID = logic.Logistics.MID,
                        //
                        Date = nameof(Date),
                        Employee = nameof(Employee),
                        Lot = nameof(Lot),
                        PSN = nameof(PSN),
                        Reactor = nameof(Reactor),
                        Recipe = nameof(Recipe),
                        //
                        Grade = nameof(Grade),
                        HeaderUniqueId = nameof(HeaderUniqueId),
                        RDS = nameof(RDS),
                        Session = nameof(Session),
                        Side = nameof(Side),
                        SrcDest = nameof(SrcDest),
                        UniqueId = nameof(UniqueId),
                        WaferID = nameof(WaferID),
                        //
                        DcnAllMax = nameof(DcnAllMax),
                        DcnAllMean = nameof(DcnAllMean),
                        DcnAllMin = nameof(DcnAllMin),
                        DcnAllStdDev = nameof(DcnAllStdDev),
                        DcnAreaCountMax = nameof(DcnAreaCountMax),
                        DcnAreaCountMean = nameof(DcnAreaCountMean),
                        DcnAreaCountMin = nameof(DcnAreaCountMin),
                        DcnAreaCountStdDev = nameof(DcnAreaCountStdDev),
                        DcnAreaMax = nameof(DcnAreaMax),
                        DcnAreaMean = nameof(DcnAreaMean),
                        DcnAreaMin = nameof(DcnAreaMin),
                        DcnAreaStdDev = nameof(DcnAreaStdDev),
                        DcnBin1Max = nameof(DcnBin1Max),
                        DcnBin1Mean = nameof(DcnBin1Mean),
                        DcnBin1Min = nameof(DcnBin1Min),
                        DcnBin1StdDev = nameof(DcnBin1StdDev),
                        DcnBin2Max = nameof(DcnBin2Max),
                        DcnBin2Mean = nameof(DcnBin2Mean),
                        DcnBin2Min = nameof(DcnBin2Min),
                        DcnBin2StdDev = nameof(DcnBin2StdDev),
                        DcnBin3Max = nameof(DcnBin3Max),
                        DcnBin3Mean = nameof(DcnBin3Mean),
                        DcnBin3Min = nameof(DcnBin3Min),
                        DcnBin3StdDev = nameof(DcnBin3StdDev),
                        DcnBin4Max = nameof(DcnBin4Max),
                        DcnBin4Mean = nameof(DcnBin4Mean),
                        DcnBin4Min = nameof(DcnBin4Min),
                        DcnBin4StdDev = nameof(DcnBin4StdDev),
                        DcnBin5Max = nameof(DcnBin5Max),
                        DcnBin5Mean = nameof(DcnBin5Mean),
                        DcnBin5Min = nameof(DcnBin5Min),
                        DcnBin5StdDev = nameof(DcnBin5StdDev),
                        DcnBin6Max = nameof(DcnBin6Max),
                        DcnBin6Mean = nameof(DcnBin6Mean),
                        DcnBin6Min = nameof(DcnBin6Min),
                        DcnBin6StdDev = nameof(DcnBin6StdDev),
                        DcnBin7Max = nameof(DcnBin7Max),
                        DcnBin7Mean = nameof(DcnBin7Mean),
                        DcnBin7Min = nameof(DcnBin7Min),
                        DcnBin7StdDev = nameof(DcnBin7StdDev),
                        DcnBin8Max = nameof(DcnBin8Max),
                        DcnBin8Mean = nameof(DcnBin8Mean),
                        DcnBin8Min = nameof(DcnBin8Min),
                        DcnBin8StdDev = nameof(DcnBin8StdDev),
                        DcnHazeAvgMax = nameof(DcnHazeAvgMax),
                        DcnHazeAvgMean = nameof(DcnHazeAvgMean),
                        DcnHazeAvgMin = nameof(DcnHazeAvgMin),
                        DcnHazeAvgStdDev = nameof(DcnHazeAvgStdDev),
                        DcnHazeMedianMax = nameof(DcnHazeMedianMax),
                        DcnHazeMedianMean = nameof(DcnHazeMedianMean),
                        DcnHazeMedianMin = nameof(DcnHazeMedianMin),
                        DcnHazeMedianStdDev = nameof(DcnHazeMedianStdDev),
                        DcnHazeStdDevMax = nameof(DcnHazeStdDevMax),
                        DcnHazeStdDevMean = nameof(DcnHazeStdDevMean),
                        DcnHazeStdDevMin = nameof(DcnHazeStdDevMin),
                        DcnHazeStdDevStdDev = nameof(DcnHazeStdDevStdDev),
                        DcnLpdESMax = nameof(DcnLpdESMax),
                        DcnLpdESMean = nameof(DcnLpdESMean),
                        DcnLpdESMin = nameof(DcnLpdESMin),
                        DcnLpdESStdDev = nameof(DcnLpdESStdDev),
                        DcnLpdMax = nameof(DcnLpdMax),
                        DcnLpdMean = nameof(DcnLpdMean),
                        DcnLpdMin = nameof(DcnLpdMin),
                        DcnLpdNMax = nameof(DcnLpdNMax),
                        DcnLpdNMean = nameof(DcnLpdNMean),
                        DcnLpdNMin = nameof(DcnLpdNMin),
                        DcnLpdNStdDev = nameof(DcnLpdNStdDev),
                        DcnLpdStdDev = nameof(DcnLpdStdDev),
                        DcnMicroScrMax = nameof(DcnMicroScrMax),
                        DcnMicroScrMean = nameof(DcnMicroScrMean),
                        DcnMicroScrMin = nameof(DcnMicroScrMin),
                        DcnMicroScrStdDev = nameof(DcnMicroScrStdDev),
                        DcnScrMax = nameof(DcnScrMax),
                        DcnScrMean = nameof(DcnScrMean),
                        DcnScrMin = nameof(DcnScrMin),
                        DcnScrStdDev = nameof(DcnScrStdDev),
                        DcnSlipMax = nameof(DcnSlipMax),
                        DcnSlipMean = nameof(DcnSlipMean),
                        DcnSlipMin = nameof(DcnSlipMin),
                        DcnSlipStdDev = nameof(DcnSlipStdDev),
                        DnnAllMax = nameof(DnnAllMax),
                        DnnAllMean = nameof(DnnAllMean),
                        DnnAllMin = nameof(DnnAllMin),
                        DnnAllStdDev = nameof(DnnAllStdDev),
                        DnnAreaCountMax = nameof(DnnAreaCountMax),
                        DnnAreaCountMean = nameof(DnnAreaCountMean),
                        DnnAreaCountMin = nameof(DnnAreaCountMin),
                        DnnAreaCountStdDev = nameof(DnnAreaCountStdDev),
                        DnnAreaMax = nameof(DnnAreaMax),
                        DnnAreaMean = nameof(DnnAreaMean),
                        DnnAreaMin = nameof(DnnAreaMin),
                        DnnAreaStdDev = nameof(DnnAreaStdDev),
                        DnnBin1Max = nameof(DnnBin1Max),
                        DnnBin1Mean = nameof(DnnBin1Mean),
                        DnnBin1Min = nameof(DnnBin1Min),
                        DnnBin1StdDev = nameof(DnnBin1StdDev),
                        DnnBin2Max = nameof(DnnBin2Max),
                        DnnBin2Mean = nameof(DnnBin2Mean),
                        DnnBin2Min = nameof(DnnBin2Min),
                        DnnBin2StdDev = nameof(DnnBin2StdDev),
                        DnnBin3Max = nameof(DnnBin3Max),
                        DnnBin3Mean = nameof(DnnBin3Mean),
                        DnnBin3Min = nameof(DnnBin3Min),
                        DnnBin3StdDev = nameof(DnnBin3StdDev),
                        DnnBin4Max = nameof(DnnBin4Max),
                        DnnBin4Mean = nameof(DnnBin4Mean),
                        DnnBin4Min = nameof(DnnBin4Min),
                        DnnBin4StdDev = nameof(DnnBin4StdDev),
                        DnnBin5Max = nameof(DnnBin5Max),
                        DnnBin5Mean = nameof(DnnBin5Mean),
                        DnnBin5Min = nameof(DnnBin5Min),
                        DnnBin5StdDev = nameof(DnnBin5StdDev),
                        DnnBin6Max = nameof(DnnBin6Max),
                        DnnBin6Mean = nameof(DnnBin6Mean),
                        DnnBin6Min = nameof(DnnBin6Min),
                        DnnBin6StdDev = nameof(DnnBin6StdDev),
                        DnnBin7Max = nameof(DnnBin7Max),
                        DnnBin7Mean = nameof(DnnBin7Mean),
                        DnnBin7Min = nameof(DnnBin7Min),
                        DnnBin7StdDev = nameof(DnnBin7StdDev),
                        DnnBin8Max = nameof(DnnBin8Max),
                        DnnBin8Mean = nameof(DnnBin8Mean),
                        DnnBin8Min = nameof(DnnBin8Min),
                        DnnBin8StdDev = nameof(DnnBin8StdDev),
                        DnnHazeAvgMax = nameof(DnnHazeAvgMax),
                        DnnHazeAvgMean = nameof(DnnHazeAvgMean),
                        DnnHazeAvgMin = nameof(DnnHazeAvgMin),
                        DnnHazeAvgStdDev = nameof(DnnHazeAvgStdDev),
                        DnnHazeMedianMax = nameof(DnnHazeMedianMax),
                        DnnHazeMedianMean = nameof(DnnHazeMedianMean),
                        DnnHazeMedianMin = nameof(DnnHazeMedianMin),
                        DnnHazeMedianStdDev = nameof(DnnHazeMedianStdDev),
                        DnnHazeStdDevMax = nameof(DnnHazeStdDevMax),
                        DnnHazeStdDevMean = nameof(DnnHazeStdDevMean),
                        DnnHazeStdDevMin = nameof(DnnHazeStdDevMin),
                        DnnHazeStdDevStdDev = nameof(DnnHazeStdDevStdDev),
                        DnnLpdESMax = nameof(DnnLpdESMax),
                        DnnLpdESMean = nameof(DnnLpdESMean),
                        DnnLpdESMin = nameof(DnnLpdESMin),
                        DnnLpdESStdDev = nameof(DnnLpdESStdDev),
                        DnnLpdMax = nameof(DnnLpdMax),
                        DnnLpdMean = nameof(DnnLpdMean),
                        DnnLpdMin = nameof(DnnLpdMin),
                        DnnLpdNMax = nameof(DnnLpdNMax),
                        DnnLpdNMean = nameof(DnnLpdNMean),
                        DnnLpdNMin = nameof(DnnLpdNMin),
                        DnnLpdNStdDev = nameof(DnnLpdNStdDev),
                        DnnLpdStdDev = nameof(DnnLpdStdDev),
                        DnnMicroScrMax = nameof(DnnMicroScrMax),
                        DnnMicroScrMean = nameof(DnnMicroScrMean),
                        DnnMicroScrMin = nameof(DnnMicroScrMin),
                        DnnMicroScrStdDev = nameof(DnnMicroScrStdDev),
                        DnnScrMax = nameof(DnnScrMax),
                        DnnScrMean = nameof(DnnScrMean),
                        DnnScrMin = nameof(DnnScrMin),
                        DnnScrStdDev = nameof(DnnScrStdDev),
                        DnnSlipMax = nameof(DnnSlipMax),
                        DnnSlipMean = nameof(DnnSlipMean),
                        DnnSlipMin = nameof(DnnSlipMin),
                        DnnSlipStdDev = nameof(DnnSlipStdDev),
                        DwnAllMax = nameof(DwnAllMax),
                        DwnAllMean = nameof(DwnAllMean),
                        DwnAllMin = nameof(DwnAllMin),
                        DwnAllStdDev = nameof(DwnAllStdDev),
                        DwnAreaCountMax = nameof(DwnAreaCountMax),
                        DwnAreaCountMean = nameof(DwnAreaCountMean),
                        DwnAreaCountMin = nameof(DwnAreaCountMin),
                        DwnAreaCountStdDev = nameof(DwnAreaCountStdDev),
                        DwnAreaMax = nameof(DwnAreaMax),
                        DwnAreaMean = nameof(DwnAreaMean),
                        DwnAreaMin = nameof(DwnAreaMin),
                        DwnAreaStdDev = nameof(DwnAreaStdDev),
                        DwnBin1Max = nameof(DwnBin1Max),
                        DwnBin1Mean = nameof(DwnBin1Mean),
                        DwnBin1Min = nameof(DwnBin1Min),
                        DwnBin1StdDev = nameof(DwnBin1StdDev),
                        DwnBin2Max = nameof(DwnBin2Max),
                        DwnBin2Mean = nameof(DwnBin2Mean),
                        DwnBin2Min = nameof(DwnBin2Min),
                        DwnBin2StdDev = nameof(DwnBin2StdDev),
                        DwnBin3Max = nameof(DwnBin3Max),
                        DwnBin3Mean = nameof(DwnBin3Mean),
                        DwnBin3Min = nameof(DwnBin3Min),
                        DwnBin3StdDev = nameof(DwnBin3StdDev),
                        DwnBin4Max = nameof(DwnBin4Max),
                        DwnBin4Mean = nameof(DwnBin4Mean),
                        DwnBin4Min = nameof(DwnBin4Min),
                        DwnBin4StdDev = nameof(DwnBin4StdDev),
                        DwnBin5Max = nameof(DwnBin5Max),
                        DwnBin5Mean = nameof(DwnBin5Mean),
                        DwnBin5Min = nameof(DwnBin5Min),
                        DwnBin5StdDev = nameof(DwnBin5StdDev),
                        DwnBin6Max = nameof(DwnBin6Max),
                        DwnBin6Mean = nameof(DwnBin6Mean),
                        DwnBin6Min = nameof(DwnBin6Min),
                        DwnBin6StdDev = nameof(DwnBin6StdDev),
                        DwnBin7Max = nameof(DwnBin7Max),
                        DwnBin7Mean = nameof(DwnBin7Mean),
                        DwnBin7Min = nameof(DwnBin7Min),
                        DwnBin7StdDev = nameof(DwnBin7StdDev),
                        DwnBin8Max = nameof(DwnBin8Max),
                        DwnBin8Mean = nameof(DwnBin8Mean),
                        DwnBin8Min = nameof(DwnBin8Min),
                        DwnBin8StdDev = nameof(DwnBin8StdDev),
                        DwnHazeAvgMax = nameof(DwnHazeAvgMax),
                        DwnHazeAvgMean = nameof(DwnHazeAvgMean),
                        DwnHazeAvgMin = nameof(DwnHazeAvgMin),
                        DwnHazeAvgStdDev = nameof(DwnHazeAvgStdDev),
                        DwnHazeMedianMax = nameof(DwnHazeMedianMax),
                        DwnHazeMedianMean = nameof(DwnHazeMedianMean),
                        DwnHazeMedianMin = nameof(DwnHazeMedianMin),
                        DwnHazeMedianStdDev = nameof(DwnHazeMedianStdDev),
                        DwnHazeStdDevMax = nameof(DwnHazeStdDevMax),
                        DwnHazeStdDevMean = nameof(DwnHazeStdDevMean),
                        DwnHazeStdDevMin = nameof(DwnHazeStdDevMin),
                        DwnHazeStdDevStdDev = nameof(DwnHazeStdDevStdDev),
                        DwnLpdESMax = nameof(DwnLpdESMax),
                        DwnLpdESMean = nameof(DwnLpdESMean),
                        DwnLpdESMin = nameof(DwnLpdESMin),
                        DwnLpdESStdDev = nameof(DwnLpdESStdDev),
                        DwnLpdMax = nameof(DwnLpdMax),
                        DwnLpdMean = nameof(DwnLpdMean),
                        DwnLpdMin = nameof(DwnLpdMin),
                        DwnLpdNMax = nameof(DwnLpdNMax),
                        DwnLpdNMean = nameof(DwnLpdNMean),
                        DwnLpdNMin = nameof(DwnLpdNMin),
                        DwnLpdNStdDev = nameof(DwnLpdNStdDev),
                        DwnLpdStdDev = nameof(DwnLpdStdDev),
                        DwnMicroScrMax = nameof(DwnMicroScrMax),
                        DwnMicroScrMean = nameof(DwnMicroScrMean),
                        DwnMicroScrMin = nameof(DwnMicroScrMin),
                        DwnMicroScrStdDev = nameof(DwnMicroScrStdDev),
                        DwnScrMax = nameof(DwnScrMax),
                        DwnScrMean = nameof(DwnScrMean),
                        DwnScrMin = nameof(DwnScrMin),
                        DwnScrStdDev = nameof(DwnScrStdDev),
                        DwnSlipMax = nameof(DwnSlipMax),
                        DwnSlipMean = nameof(DwnSlipMean),
                        DwnSlipMin = nameof(DwnSlipMin),
                        DwnSlipStdDev = nameof(DwnSlipStdDev),
                        DcnAll = nameof(DcnAll),
                        DcnArea = nameof(DcnArea),
                        DcnAreaCount = nameof(DcnAreaCount),
                        DcnBin1 = nameof(DcnBin1),
                        DcnBin2 = nameof(DcnBin2),
                        DcnBin3 = nameof(DcnBin3),
                        DcnBin4 = nameof(DcnBin4),
                        DcnBin5 = nameof(DcnBin5),
                        DcnBin6 = nameof(DcnBin6),
                        DcnBin7 = nameof(DcnBin7),
                        DcnBin8 = nameof(DcnBin8),
                        DcnHazeAvg = nameof(DcnHazeAvg),
                        DcnHazeMedian = nameof(DcnHazeMedian),
                        DcnHazeStdDev = nameof(DcnHazeStdDev),
                        DcnLpd = nameof(DcnLpd),
                        DcnLpdES = nameof(DcnLpdES),
                        DcnLpdN = nameof(DcnLpdN),
                        DcnMicroScr = nameof(DcnMicroScr),
                        DcnScr = nameof(DcnScr),
                        DcnSlip = nameof(DcnSlip),
                        DnnAll = nameof(DnnAll),
                        DnnArea = nameof(DnnArea),
                        DnnAreaCount = nameof(DnnAreaCount),
                        DnnBin1 = nameof(DnnBin1),
                        DnnBin2 = nameof(DnnBin2),
                        DnnBin3 = nameof(DnnBin3),
                        DnnBin4 = nameof(DnnBin4),
                        DnnBin5 = nameof(DnnBin5),
                        DnnBin6 = nameof(DnnBin6),
                        DnnBin7 = nameof(DnnBin7),
                        DnnBin8 = nameof(DnnBin8),
                        DnnHazeAvg = nameof(DnnHazeAvg),
                        DnnHazeMedian = nameof(DnnHazeMedian),
                        DnnHazeStdDev = nameof(DnnHazeStdDev),
                        DnnLpd = nameof(DnnLpd),
                        DnnLpdES = nameof(DnnLpdES),
                        DnnLpdN = nameof(DnnLpdN),
                        DnnMicroScr = nameof(DnnMicroScr),
                        DnnScr = nameof(DnnScr),
                        DnnSlip = nameof(DnnSlip),
                        DwnAll = nameof(DwnAll),
                        DwnArea = nameof(DwnArea),
                        DwnAreaCount = nameof(DwnAreaCount),
                        DwnBin1 = nameof(DwnBin1),
                        DwnBin2 = nameof(DwnBin2),
                        DwnBin3 = nameof(DwnBin3),
                        DwnBin4 = nameof(DwnBin4),
                        DwnBin5 = nameof(DwnBin5),
                        DwnBin6 = nameof(DwnBin6),
                        DwnBin7 = nameof(DwnBin7),
                        DwnBin8 = nameof(DwnBin8),
                        DwnHazeAvg = nameof(DwnHazeAvg),
                        DwnHazeMedian = nameof(DwnHazeMedian),
                        DwnHazeStdDev = nameof(DwnHazeStdDev),
                        DwnLpd = nameof(DwnLpd),
                        DwnLpdES = nameof(DwnLpdES),
                        DwnLpdN = nameof(DwnLpdN),
                        DwnMicroScr = nameof(DwnMicroScr),
                        DwnScr = nameof(DwnScr),
                        DwnSlip = nameof(DwnSlip),
                    };
                    return result;
                }

                public List<IProcessDataDescription> GetDescription(ILogic logic, ConfigDataBase configDataBase, List<Test> tests, IProcessData iProcessData)
                {
                    List<IProcessDataDescription> results = new List<IProcessDataDescription>();
                    if (iProcessData is null || !(iProcessData is ProcessData processData) || processData.Header is null || !processData.Details.Any())
                        results.Add(GetDefault(logic, configDataBase));
                    else
                    {
                        string nullData;
                        Description description;
                        object configDataNullData = ConfigData.NullData;
                        if (configDataNullData is null)
                            nullData = string.Empty;
                        else
                            nullData = configDataNullData.ToString();
                        for (int i = 0; i < processData.Details.Count; i++)
                        {
                            description = new Description
                            {
                                Test = (int)tests[i],
                                Count = tests.Count,
                                Index = i,
                                //
                                EventName = configDataBase.GetEventName(),
                                NullData = nullData,
                                JobID = logic.Logistics.JobID,
                                Sequence = logic.Logistics.Sequence.ToString(),
                                MesEntity = logic.Logistics.MesEntity,
                                ReportFullPath = logic.Logistics.ReportFullPath,
                                ProcessJobID = logic.Logistics.ProcessJobID,
                                MID = logic.Logistics.MID,
                                //
                                Date = processData.Header.Date,
                                Employee = processData.Header.Operator,
                                Lot = processData.Header.Lot,
                                PSN = processData.Header.PSN,
                                Reactor = processData.Header.Reactor,
                                Recipe = processData.Header.Recipe,
                                //
                                Grade = processData.Details[i].Grade,
                                HeaderUniqueId = processData.Details[i].HeaderUniqueID,
                                RDS = processData.Header.RDS,
                                Session = processData.Header.Session,
                                Side = processData.Details[i].Side,
                                SrcDest = processData.Details[i].SrcDest,
                                UniqueId = processData.Details[i].UniqueID,
                                WaferID = processData.Details[i].WaferID,
                                //
                                DcnAllMax = processData.Header.DcnAllMax,
                                DcnAllMean = processData.Header.DcnAllMean,
                                DcnAllMin = processData.Header.DcnAllMin,
                                DcnAllStdDev = processData.Header.DcnAllStdDev,
                                DcnAreaCountMax = processData.Header.DcnAreaCountMax,
                                DcnAreaCountMean = processData.Header.DcnAreaCountMean,
                                DcnAreaCountMin = processData.Header.DcnAreaCountMin,
                                DcnAreaCountStdDev = processData.Header.DcnAreaCountStdDev,
                                DcnAreaMax = processData.Header.DcnAreaMax,
                                DcnAreaMean = processData.Header.DcnAreaMean,
                                DcnAreaMin = processData.Header.DcnAreaMin,
                                DcnAreaStdDev = processData.Header.DcnAreaStdDev,
                                DcnBin1Max = processData.Header.DcnBin1Max,
                                DcnBin1Mean = processData.Header.DcnBin1Mean,
                                DcnBin1Min = processData.Header.DcnBin1Min,
                                DcnBin1StdDev = processData.Header.DcnBin1StdDev,
                                DcnBin2Max = processData.Header.DcnBin2Max,
                                DcnBin2Mean = processData.Header.DcnBin2Mean,
                                DcnBin2Min = processData.Header.DcnBin2Min,
                                DcnBin2StdDev = processData.Header.DcnBin2StdDev,
                                DcnBin3Max = processData.Header.DcnBin3Max,
                                DcnBin3Mean = processData.Header.DcnBin3Mean,
                                DcnBin3Min = processData.Header.DcnBin3Min,
                                DcnBin3StdDev = processData.Header.DcnBin3StdDev,
                                DcnBin4Max = processData.Header.DcnBin4Max,
                                DcnBin4Mean = processData.Header.DcnBin4Mean,
                                DcnBin4Min = processData.Header.DcnBin4Min,
                                DcnBin4StdDev = processData.Header.DcnBin4StdDev,
                                DcnBin5Max = processData.Header.DcnBin5Max,
                                DcnBin5Mean = processData.Header.DcnBin5Mean,
                                DcnBin5Min = processData.Header.DcnBin5Min,
                                DcnBin5StdDev = processData.Header.DcnBin5StdDev,
                                DcnBin6Max = processData.Header.DcnBin6Max,
                                DcnBin6Mean = processData.Header.DcnBin6Mean,
                                DcnBin6Min = processData.Header.DcnBin6Min,
                                DcnBin6StdDev = processData.Header.DcnBin6StdDev,
                                DcnBin7Max = processData.Header.DcnBin7Max,
                                DcnBin7Mean = processData.Header.DcnBin7Mean,
                                DcnBin7Min = processData.Header.DcnBin7Min,
                                DcnBin7StdDev = processData.Header.DcnBin7StdDev,
                                DcnBin8Max = processData.Header.DcnBin8Max,
                                DcnBin8Mean = processData.Header.DcnBin8Mean,
                                DcnBin8Min = processData.Header.DcnBin8Min,
                                DcnBin8StdDev = processData.Header.DcnBin8StdDev,
                                DcnHazeAvgMax = processData.Header.DcnHazeAvgMax,
                                DcnHazeAvgMean = processData.Header.DcnHazeAvgMean,
                                DcnHazeAvgMin = processData.Header.DcnHazeAvgMin,
                                DcnHazeAvgStdDev = processData.Header.DcnHazeAvgStdDev,
                                DcnHazeMedianMax = processData.Header.DcnHazeMedianMax,
                                DcnHazeMedianMean = processData.Header.DcnHazeMedianMean,
                                DcnHazeMedianMin = processData.Header.DcnHazeMedianMin,
                                DcnHazeMedianStdDev = processData.Header.DcnHazeMedianStdDev,
                                DcnHazeStdDevMax = processData.Header.DcnHazeStdDevMax,
                                DcnHazeStdDevMean = processData.Header.DcnHazeStdDevMean,
                                DcnHazeStdDevMin = processData.Header.DcnHazeStdDevMin,
                                DcnHazeStdDevStdDev = processData.Header.DcnHazeStdDevStdDev,
                                DcnLpdESMax = processData.Header.DcnLpdESMax,
                                DcnLpdESMean = processData.Header.DcnLpdESMean,
                                DcnLpdESMin = processData.Header.DcnLpdESMin,
                                DcnLpdESStdDev = processData.Header.DcnLpdESStdDev,
                                DcnLpdMax = processData.Header.DcnLpdMax,
                                DcnLpdMean = processData.Header.DcnLpdMean,
                                DcnLpdMin = processData.Header.DcnLpdMin,
                                DcnLpdNMax = processData.Header.DcnLpdNMax,
                                DcnLpdNMean = processData.Header.DcnLpdNMean,
                                DcnLpdNMin = processData.Header.DcnLpdNMin,
                                DcnLpdNStdDev = processData.Header.DcnLpdNStdDev,
                                DcnLpdStdDev = processData.Header.DcnLpdStdDev,
                                DcnMicroScrMax = processData.Header.DcnMicroScrMax,
                                DcnMicroScrMean = processData.Header.DcnMicroScrMean,
                                DcnMicroScrMin = processData.Header.DcnMicroScrMin,
                                DcnMicroScrStdDev = processData.Header.DcnMicroScrStdDev,
                                DcnScrMax = processData.Header.DcnScrMax,
                                DcnScrMean = processData.Header.DcnScrMean,
                                DcnScrMin = processData.Header.DcnScrMin,
                                DcnScrStdDev = processData.Header.DcnScrStdDev,
                                DcnSlipMax = processData.Header.DcnSlipMax,
                                DcnSlipMean = processData.Header.DcnSlipMean,
                                DcnSlipMin = processData.Header.DcnSlipMin,
                                DcnSlipStdDev = processData.Header.DcnSlipStdDev,
                                DnnAllMax = processData.Header.DnnAllMax,
                                DnnAllMean = processData.Header.DnnAllMean,
                                DnnAllMin = processData.Header.DnnAllMin,
                                DnnAllStdDev = processData.Header.DnnAllStdDev,
                                DnnAreaCountMax = processData.Header.DnnAreaCountMax,
                                DnnAreaCountMean = processData.Header.DnnAreaCountMean,
                                DnnAreaCountMin = processData.Header.DnnAreaCountMin,
                                DnnAreaCountStdDev = processData.Header.DnnAreaCountStdDev,
                                DnnAreaMax = processData.Header.DnnAreaMax,
                                DnnAreaMean = processData.Header.DnnAreaMean,
                                DnnAreaMin = processData.Header.DnnAreaMin,
                                DnnAreaStdDev = processData.Header.DnnAreaStdDev,
                                DnnBin1Max = processData.Header.DnnBin1Max,
                                DnnBin1Mean = processData.Header.DnnBin1Mean,
                                DnnBin1Min = processData.Header.DnnBin1Min,
                                DnnBin1StdDev = processData.Header.DnnBin1StdDev,
                                DnnBin2Max = processData.Header.DnnBin2Max,
                                DnnBin2Mean = processData.Header.DnnBin2Mean,
                                DnnBin2Min = processData.Header.DnnBin2Min,
                                DnnBin2StdDev = processData.Header.DnnBin2StdDev,
                                DnnBin3Max = processData.Header.DnnBin3Max,
                                DnnBin3Mean = processData.Header.DnnBin3Mean,
                                DnnBin3Min = processData.Header.DnnBin3Min,
                                DnnBin3StdDev = processData.Header.DnnBin3StdDev,
                                DnnBin4Max = processData.Header.DnnBin4Max,
                                DnnBin4Mean = processData.Header.DnnBin4Mean,
                                DnnBin4Min = processData.Header.DnnBin4Min,
                                DnnBin4StdDev = processData.Header.DnnBin4StdDev,
                                DnnBin5Max = processData.Header.DnnBin5Max,
                                DnnBin5Mean = processData.Header.DnnBin5Mean,
                                DnnBin5Min = processData.Header.DnnBin5Min,
                                DnnBin5StdDev = processData.Header.DnnBin5StdDev,
                                DnnBin6Max = processData.Header.DnnBin6Max,
                                DnnBin6Mean = processData.Header.DnnBin6Mean,
                                DnnBin6Min = processData.Header.DnnBin6Min,
                                DnnBin6StdDev = processData.Header.DnnBin6StdDev,
                                DnnBin7Max = processData.Header.DnnBin7Max,
                                DnnBin7Mean = processData.Header.DnnBin7Mean,
                                DnnBin7Min = processData.Header.DnnBin7Min,
                                DnnBin7StdDev = processData.Header.DnnBin7StdDev,
                                DnnBin8Max = processData.Header.DnnBin8Max,
                                DnnBin8Mean = processData.Header.DnnBin8Mean,
                                DnnBin8Min = processData.Header.DnnBin8Min,
                                DnnBin8StdDev = processData.Header.DnnBin8StdDev,
                                DnnHazeAvgMax = processData.Header.DnnHazeAvgMax,
                                DnnHazeAvgMean = processData.Header.DnnHazeAvgMean,
                                DnnHazeAvgMin = processData.Header.DnnHazeAvgMin,
                                DnnHazeAvgStdDev = processData.Header.DnnHazeAvgStdDev,
                                DnnHazeMedianMax = processData.Header.DnnHazeMedianMax,
                                DnnHazeMedianMean = processData.Header.DnnHazeMedianMean,
                                DnnHazeMedianMin = processData.Header.DnnHazeMedianMin,
                                DnnHazeMedianStdDev = processData.Header.DnnHazeMedianStdDev,
                                DnnHazeStdDevMax = processData.Header.DnnHazeStdDevMax,
                                DnnHazeStdDevMean = processData.Header.DnnHazeStdDevMean,
                                DnnHazeStdDevMin = processData.Header.DnnHazeStdDevMin,
                                DnnHazeStdDevStdDev = processData.Header.DnnHazeStdDevStdDev,
                                DnnLpdESMax = processData.Header.DnnLpdESMax,
                                DnnLpdESMean = processData.Header.DnnLpdESMean,
                                DnnLpdESMin = processData.Header.DnnLpdESMin,
                                DnnLpdESStdDev = processData.Header.DnnLpdESStdDev,
                                DnnLpdMax = processData.Header.DnnLpdMax,
                                DnnLpdMean = processData.Header.DnnLpdMean,
                                DnnLpdMin = processData.Header.DnnLpdMin,
                                DnnLpdNMax = processData.Header.DnnLpdNMax,
                                DnnLpdNMean = processData.Header.DnnLpdNMean,
                                DnnLpdNMin = processData.Header.DnnLpdNMin,
                                DnnLpdNStdDev = processData.Header.DnnLpdNStdDev,
                                DnnLpdStdDev = processData.Header.DnnLpdStdDev,
                                DnnMicroScrMax = processData.Header.DnnMicroScrMax,
                                DnnMicroScrMean = processData.Header.DnnMicroScrMean,
                                DnnMicroScrMin = processData.Header.DnnMicroScrMin,
                                DnnMicroScrStdDev = processData.Header.DnnMicroScrStdDev,
                                DnnScrMax = processData.Header.DnnScrMax,
                                DnnScrMean = processData.Header.DnnScrMean,
                                DnnScrMin = processData.Header.DnnScrMin,
                                DnnScrStdDev = processData.Header.DnnScrStdDev,
                                DnnSlipMax = processData.Header.DnnSlipMax,
                                DnnSlipMean = processData.Header.DnnSlipMean,
                                DnnSlipMin = processData.Header.DnnSlipMin,
                                DnnSlipStdDev = processData.Header.DnnSlipStdDev,
                                DwnAllMax = processData.Header.DwnAllMax,
                                DwnAllMean = processData.Header.DwnAllMean,
                                DwnAllMin = processData.Header.DwnAllMin,
                                DwnAllStdDev = processData.Header.DwnAllStdDev,
                                DwnAreaCountMax = processData.Header.DwnAreaCountMax,
                                DwnAreaCountMean = processData.Header.DwnAreaCountMean,
                                DwnAreaCountMin = processData.Header.DwnAreaCountMin,
                                DwnAreaCountStdDev = processData.Header.DwnAreaCountStdDev,
                                DwnAreaMax = processData.Header.DwnAreaMax,
                                DwnAreaMean = processData.Header.DwnAreaMean,
                                DwnAreaMin = processData.Header.DwnAreaMin,
                                DwnAreaStdDev = processData.Header.DwnAreaStdDev,
                                DwnBin1Max = processData.Header.DwnBin1Max,
                                DwnBin1Mean = processData.Header.DwnBin1Mean,
                                DwnBin1Min = processData.Header.DwnBin1Min,
                                DwnBin1StdDev = processData.Header.DwnBin1StdDev,
                                DwnBin2Max = processData.Header.DwnBin2Max,
                                DwnBin2Mean = processData.Header.DwnBin2Mean,
                                DwnBin2Min = processData.Header.DwnBin2Min,
                                DwnBin2StdDev = processData.Header.DwnBin2StdDev,
                                DwnBin3Max = processData.Header.DwnBin3Max,
                                DwnBin3Mean = processData.Header.DwnBin3Mean,
                                DwnBin3Min = processData.Header.DwnBin3Min,
                                DwnBin3StdDev = processData.Header.DwnBin3StdDev,
                                DwnBin4Max = processData.Header.DwnBin4Max,
                                DwnBin4Mean = processData.Header.DwnBin4Mean,
                                DwnBin4Min = processData.Header.DwnBin4Min,
                                DwnBin4StdDev = processData.Header.DwnBin4StdDev,
                                DwnBin5Max = processData.Header.DwnBin5Max,
                                DwnBin5Mean = processData.Header.DwnBin5Mean,
                                DwnBin5Min = processData.Header.DwnBin5Min,
                                DwnBin5StdDev = processData.Header.DwnBin5StdDev,
                                DwnBin6Max = processData.Header.DwnBin6Max,
                                DwnBin6Mean = processData.Header.DwnBin6Mean,
                                DwnBin6Min = processData.Header.DwnBin6Min,
                                DwnBin6StdDev = processData.Header.DwnBin6StdDev,
                                DwnBin7Max = processData.Header.DwnBin7Max,
                                DwnBin7Mean = processData.Header.DwnBin7Mean,
                                DwnBin7Min = processData.Header.DwnBin7Min,
                                DwnBin7StdDev = processData.Header.DwnBin7StdDev,
                                DwnBin8Max = processData.Header.DwnBin8Max,
                                DwnBin8Mean = processData.Header.DwnBin8Mean,
                                DwnBin8Min = processData.Header.DwnBin8Min,
                                DwnBin8StdDev = processData.Header.DwnBin8StdDev,
                                DwnHazeAvgMax = processData.Header.DwnHazeAvgMax,
                                DwnHazeAvgMean = processData.Header.DwnHazeAvgMean,
                                DwnHazeAvgMin = processData.Header.DwnHazeAvgMin,
                                DwnHazeAvgStdDev = processData.Header.DwnHazeAvgStdDev,
                                DwnHazeMedianMax = processData.Header.DwnHazeMedianMax,
                                DwnHazeMedianMean = processData.Header.DwnHazeMedianMean,
                                DwnHazeMedianMin = processData.Header.DwnHazeMedianMin,
                                DwnHazeMedianStdDev = processData.Header.DwnHazeMedianStdDev,
                                DwnHazeStdDevMax = processData.Header.DwnHazeStdDevMax,
                                DwnHazeStdDevMean = processData.Header.DwnHazeStdDevMean,
                                DwnHazeStdDevMin = processData.Header.DwnHazeStdDevMin,
                                DwnHazeStdDevStdDev = processData.Header.DwnHazeStdDevStdDev,
                                DwnLpdESMax = processData.Header.DwnLpdESMax,
                                DwnLpdESMean = processData.Header.DwnLpdESMean,
                                DwnLpdESMin = processData.Header.DwnLpdESMin,
                                DwnLpdESStdDev = processData.Header.DwnLpdESStdDev,
                                DwnLpdMax = processData.Header.DwnLpdMax,
                                DwnLpdMean = processData.Header.DwnLpdMean,
                                DwnLpdMin = processData.Header.DwnLpdMin,
                                DwnLpdNMax = processData.Header.DwnLpdNMax,
                                DwnLpdNMean = processData.Header.DwnLpdNMean,
                                DwnLpdNMin = processData.Header.DwnLpdNMin,
                                DwnLpdNStdDev = processData.Header.DwnLpdNStdDev,
                                DwnLpdStdDev = processData.Header.DwnLpdStdDev,
                                DwnMicroScrMax = processData.Header.DwnMicroScrMax,
                                DwnMicroScrMean = processData.Header.DwnMicroScrMean,
                                DwnMicroScrMin = processData.Header.DwnMicroScrMin,
                                DwnMicroScrStdDev = processData.Header.DwnMicroScrStdDev,
                                DwnScrMax = processData.Header.DwnScrMax,
                                DwnScrMean = processData.Header.DwnScrMean,
                                DwnScrMin = processData.Header.DwnScrMin,
                                DwnScrStdDev = processData.Header.DwnScrStdDev,
                                DwnSlipMax = processData.Header.DwnSlipMax,
                                DwnSlipMean = processData.Header.DwnSlipMean,
                                DwnSlipMin = processData.Header.DwnSlipMin,
                                DwnSlipStdDev = processData.Header.DwnSlipStdDev,
                                DcnAll = processData.Details[i].DcnAll,
                                DcnArea = processData.Details[i].DcnArea,
                                DcnAreaCount = processData.Details[i].DcnAreaCount,
                                DcnBin1 = processData.Details[i].DcnBin1,
                                DcnBin2 = processData.Details[i].DcnBin2,
                                DcnBin3 = processData.Details[i].DcnBin3,
                                DcnBin4 = processData.Details[i].DcnBin4,
                                DcnBin5 = processData.Details[i].DcnBin5,
                                DcnBin6 = processData.Details[i].DcnBin6,
                                DcnBin7 = processData.Details[i].DcnBin7,
                                DcnBin8 = processData.Details[i].DcnBin8,
                                DcnHazeAvg = processData.Details[i].DcnHazeAvg,
                                DcnHazeMedian = processData.Details[i].DcnHazeMedian,
                                DcnHazeStdDev = processData.Details[i].DcnHazeStdDev,
                                DcnLpd = processData.Details[i].DcnLpd,
                                DcnLpdES = processData.Details[i].DcnLpdES,
                                DcnLpdN = processData.Details[i].DcnLpdN,
                                DcnMicroScr = processData.Details[i].DcnMicroScr,
                                DcnScr = processData.Details[i].DcnScr,
                                DcnSlip = processData.Details[i].DcnSlip,
                                DnnAll = processData.Details[i].DnnAll,
                                DnnArea = processData.Details[i].DnnArea,
                                DnnAreaCount = processData.Details[i].DnnAreaCount,
                                DnnBin1 = processData.Details[i].DnnBin1,
                                DnnBin2 = processData.Details[i].DnnBin2,
                                DnnBin3 = processData.Details[i].DnnBin3,
                                DnnBin4 = processData.Details[i].DnnBin4,
                                DnnBin5 = processData.Details[i].DnnBin5,
                                DnnBin6 = processData.Details[i].DnnBin6,
                                DnnBin7 = processData.Details[i].DnnBin7,
                                DnnBin8 = processData.Details[i].DnnBin8,
                                DnnHazeAvg = processData.Details[i].DnnHazeAvg,
                                DnnHazeMedian = processData.Details[i].DnnHazeMedian,
                                DnnHazeStdDev = processData.Details[i].DnnHazeStdDev,
                                DnnLpd = processData.Details[i].DnnLpd,
                                DnnLpdES = processData.Details[i].DnnLpdES,
                                DnnLpdN = processData.Details[i].DnnLpdN,
                                DnnMicroScr = processData.Details[i].DnnMicroScr,
                                DnnScr = processData.Details[i].DnnScr,
                                DnnSlip = processData.Details[i].DnnSlip,
                                DwnAll = processData.Details[i].DwnAll,
                                DwnArea = processData.Details[i].DwnArea,
                                DwnAreaCount = processData.Details[i].DwnAreaCount,
                                DwnBin1 = processData.Details[i].DwnBin1,
                                DwnBin2 = processData.Details[i].DwnBin2,
                                DwnBin3 = processData.Details[i].DwnBin3,
                                DwnBin4 = processData.Details[i].DwnBin4,
                                DwnBin5 = processData.Details[i].DwnBin5,
                                DwnBin6 = processData.Details[i].DwnBin6,
                                DwnBin7 = processData.Details[i].DwnBin7,
                                DwnBin8 = processData.Details[i].DwnBin8,
                                DwnHazeAvg = processData.Details[i].DwnHazeAvg,
                                DwnHazeMedian = processData.Details[i].DwnHazeMedian,
                                DwnHazeStdDev = processData.Details[i].DwnHazeStdDev,
                                DwnLpd = processData.Details[i].DwnLpd,
                                DwnLpdES = processData.Details[i].DwnLpdES,
                                DwnLpdN = processData.Details[i].DwnLpdN,
                                DwnMicroScr = processData.Details[i].DwnMicroScr,
                                DwnScr = processData.Details[i].DwnScr,
                                DwnSlip = processData.Details[i].DwnSlip
                            };
                            results.Add(description);
                        }
                    }
                    return results;
                }

            }

        }

    }

}