﻿using System;

namespace Adaptation.Shared.Metrology
{

    public static class ColumnGet
    {

        public static string GetDiplayName(this Column column)
        {
            string results;
            switch (column)
            {
                //case Column._8in_Total_Warp_Verification: results = "8in Total Warp Verification"; break;
                //case Column.AFM_Monthly_Y: results = "AFM-Monthly Y"; break;
                //case Column.AFM_Monthly: results = "AFM_Monthly"; break;
                case Column.AFM_Pit_Count:
                    results = "AFM Pit Count";
                    break;
                case Column.AFM_Roughness:
                    results = "AFM Roughness";
                    break;
                //case Column.Adder_Bin_1: results = "Adder Bin 1"; break;
                //case Column.Adder_Bin_2: results = "Adder Bin 2"; break;
                //case Column.Adder_Bin_3: results = "Adder Bin 3"; break;
                //case Column.Adder_Bin_4: results = "Adder Bin 4"; break;
                //case Column.Adder_Bin_5: results = "Adder Bin 5"; break;
                //case Column.Adder_Bin_6: results = "Adder Bin 6"; break;
                //case Column.Adder_Bin_9: results = "Adder Bin 9"; break;
                case Column.Al_B_B_WTAVG:
                    results = "Al% B.B. WTAVG";
                    break;
                case Column.Al_B_B_:
                    results = "Al% B.B.";
                    break;
                case Column.Al_Barrier_WTAVG:
                    results = "Al% Barrier WTAVG";
                    break;
                case Column.Al_Barrier:
                    results = "Al% Barrier";
                    break;
                case Column.Al_SLS_WTAVG:
                    results = "Al% SLS WTAVG";
                    break;
                case Column.Al_SLS:
                    results = "Al% SLS";
                    break;
                case Column.Al_TL1_WTAVG:
                    results = "Al% TL1 WTAVG";
                    break;
                case Column.Al_TL1:
                    results = "Al% TL1";
                    break;
                case Column.Al_TL2_WTAVG:
                    results = "Al% TL2 WTAVG";
                    break;
                //case Column.BV_Resistance: results = "BV Resistance"; break; //BV Monthly Verification
                case Column.BandEdge_V:
                    results = "BandEdge_V";
                    break;
                case Column.BandEdge_V_XY:
                    results = "BandEdge_V_XY";
                    break;
                case Column.BandEdge_nm:
                    results = "BandEdge_nm";
                    break;
                case Column.Barrier_Composition_RPM_XY:
                    results = "Barrier_Composition_RPM_XY";
                    break;
                case Column.Bow_Calibration:
                    results = "Bow Calibration";
                    break;
                case Column.Bow_Range:
                    results = "Bow Range";
                    break;
                case Column.Bow:
                    results = "Bow";
                    break;
                case Column.BowCenter:
                    results = "BowCenter";
                    break;
                case Column.BowX:
                    results = "BowX";
                    break;
                case Column.BowY:
                    results = "BowY";
                    break;
                case Column.Breakdown_Voltage_Edge:
                    results = "Breakdown Voltage - Edge";
                    break;
                case Column.Breakdown_VoltageMiddle:
                    results = "Breakdown Voltage - Middle";
                    break;
                case Column.Breakdown_Voltage:
                    results = "Breakdown Voltage";
                    break;
                case Column.CV_C_at_10V:
                    results = "CV C at -10V";
                    break;
                case Column.CV_Nd_Min:
                    results = "CV Nd Min";
                    break;
                //case Column.Candela_Large_LPD_Quarterly: results = "Candela Large LPD Quarterly"; break;
                //case Column.Candela_Medium_LPD_Quarterly: results = "Candela Medium LPD Quarterly"; break;
                //case Column.Candela_Small_LPD_Quarterly: results = "Candela Small LPD Quarterly"; break;
                //case Column.Candela_Total_Quarterly: results = "Candela Total Quarterly"; break;
                case Column.Candela_102_83nm:
                    results = "102-83nm";
                    break;
                case Column.Candela_1_1um:
                    results = "1.1um";
                    break;
                case Column.Candela_496nm:
                    results = "496nm";
                    break;
                case Column.Candela_600nm:
                    results = "600nm";
                    break;
                case Column.Candela_8620_Small:
                    results = "Candela 8620 Small";
                    break;
                case Column.Candela_Crack_Verification:
                    results = "Crack Verification";
                    break;
                case Column.Candela_Cracking:
                    results = "Candela Cracking";
                    break;
                case Column.Candela_Cracking_Acceptable:
                    results = "Candela Cracking Acceptable";
                    break;
                case Column.Candela_Crater:
                    results = "Candela Crater";
                    break;
                case Column.Candela_Crater_Verification:
                    results = "Crater verification";
                    break;
                case Column.Candela_Haze:
                    results = "Candela Haze";
                    break;
                case Column.Candela_LPD_Large:
                    results = "Candela LPD Large";
                    break;
                case Column.Candela_LPD_Medium:
                    results = "Candela LPD Medium";
                    break;
                case Column.Candela_LPD_Small:
                    results = "Candela LPD Small";
                    break;
                case Column.Candela_Large_Verification:
                    results = "Large Verification";
                    break;
                case Column.Candela_Medium_Verification:
                    results = "Medium Verification";
                    break;
                case Column.Candela_Pits:
                    results = "Candela Pits";
                    break;
                case Column.Candela_Pits_Verification:
                    results = "Pits verification";
                    break;
                case Column.Candela_SPE:
                    results = "Candela SPE";
                    break;
                case Column.Candela_SPE_Verification:
                    results = "SPE verification";
                    break;
                case Column.Candela_Slip:
                    results = "Candela Slip";
                    break;
                case Column.Candela_Small_Verification:
                    results = "Small Verification";
                    break;
                case Column.Candela_Spirals:
                    results = "Candela Spirals";
                    break;
                case Column.Candela_Spirals_Verification:
                    results = "Candela Spirals Verification";
                    break;
                case Column.Candela_Total_Defects:
                    results = "Candela Total Defects";
                    break;
                case Column.Candela_Total_PSL:
                    results = "Candela Total PSL";
                    break;
                case Column.Candela__1_1um:
                    results = ">1.1um";
                    break;
                //case Column.Comment: results = "Comment"; break;
                //case Column.Conductivity: results = "Conductivity"; break;
                case Column.Contact_Symmetry:
                    results = "Contact Symmetry";
                    break;
                //case Column.Cracking_verification: results = "Cracking verification"; break;
                //case Column.Crater_verification: results = "Crater verification"; break;
                case Column.Date:
                    results = "Date";
                    break;
                case Column.Denton_Crystal_Life:
                    results = "Denton_Crystal_Life";
                    break;
                case Column.Denton_Current_AVG:
                    results = "Denton_Current_AVG";
                    break;
                case Column.Denton_Current_STDEV:
                    results = "Denton_Current_STDEV";
                    break;
                case Column.Denton_Deposition_Power_AVG:
                    results = "Denton_Deposition_Power_AVG";
                    break;
                case Column.Denton_Deposition_Power_STDEV:
                    results = "Denton_Deposition_Power_STDEV";
                    break;
                case Column.Denton_Deposition_Rate_AVG:
                    results = "Denton_Deposition_Rate_AVG";
                    break;
                case Column.Denton_Deposition_Rate_STDEV:
                    results = "Denton_Deposition_Rate_STDEV";
                    break;
                case Column.Denton_Gun_Pocket:
                    results = "Denton_Gun_Pocket";
                    break;
                case Column.Denton_Pumpdown_Time:
                    results = "Denton_Pumpdown_Time";
                    break;
                case Column.Denton_Voltage_AVG:
                    results = "Denton_Voltage_AVG";
                    break;
                case Column.Denton_Voltage_STDEV:
                    results = "Denton_Voltage_STDEV";
                    break;
                case Column.Employee:
                    results = "Employee";
                    break;
                case Column.Epi_Thickness_Mean:
                    results = "Epi Thickness Mean";
                    break;
                case Column.Epi_Thickness_Mean_XY:
                    results = "Epi Thickness Mean_XY";
                    break;
                case Column.Epi_Thickness_Std_Dev_:
                    results = "Epi Thickness Std Dev %";
                    break;
                case Column.FWHM_006_WTAVG:
                    results = "FWHM 006 WTAVG";
                    break;
                case Column.FWHM_006:
                    results = "FWHM 006";
                    break;
                case Column.FWHM_105_WTAVG:
                    results = "FWHM 105 WTAVG";
                    break;
                case Column.FWHM_105:
                    results = "FWHM 105";
                    break;
                case Column.Hall_Rs:
                    results = "Hall Rs";
                    break;
                case Column.Hall_Mobility_verif_sample:
                    results = "Hall_Mobility_verif_sample";
                    break;
                case Column.Hall_Ns_verif_sample:
                    results = "Hall_Ns_verif_sample";
                    break;
                case Column.Hall_Rs_verif_sample:
                    results = "Hall_Rs_verif_sample";
                    break;
                case Column.Job:
                    results = "Job";
                    break;
                case Column.LEI_RS_Average_value:
                    results = "LEI RS Average value";
                    break;
                case Column.LEI_RS_Maximum_value:
                    results = "LEI RS Maximum value";
                    break;
                case Column.LEI_RS_Minimum_value:
                    results = "LEI RS Minimum value";
                    break;
                case Column.LEI_RS_STDEV:
                    results = "LEI RS STDEV";
                    break;
                case Column.LEI_RS_STDEV_:
                    results = "LEI RS STDEV%";
                    break;
                //case Column.Large_Adder_Sum: results = "Large Adder Sum"; break;
                case Column.Lot:
                    results = "Lot";
                    break;
                //case Column.Medium_Adder_Sum: results = "Medium Adder Sum"; break;
                case Column.Microscope_Center_5x:
                    results = "Microscope Center 5x";
                    break;
                case Column.Microscope_Center_50x:
                    results = "Microscope Center 50x";
                    break;
                case Column.Microscope_Middle_5x:
                    results = "Microscope Middle 5x";
                    break;
                case Column.Microscope_Middle_50x:
                    results = "Microscope Middle 50x";
                    break;
                case Column.Microscope_Edge_5x:
                    results = "Microscope Edge 5x";
                    break;
                case Column.Microscope_Edge_50x:
                    results = "Microscope Edge 50x";
                    break;
                case Column.Mobility_Verification:
                    results = "Mobility Verification";
                    break;
                case Column.Mobility:
                    results = "Mobility";
                    break;
                case Column.Ns_Verification:
                    results = "Ns Verification";
                    break;
                case Column.PL_Edge_Wavelength:
                    results = "PL Edge Wavelength";
                    break;
                case Column.PL_Ratio:
                    results = "PL Ratio";
                    break;
                case Column.PR_Barrier_Composition:
                    results = "PR Barrier Composition";
                    break;
                case Column.PR_Peak:
                    results = "PR Peak";
                    break;
                case Column.Part:
                    results = "Part";
                    break;
                //case Column.Particles_verification: results = "Particles verification"; break;
                //case Column.Pits_verification: results = "Pits verification"; break;
                //case Column.Pocket: results = "Pocket"; break;
                //case Column.Post_Bin_1: results = "Post Bin 1"; break;
                //case Column.Post_Bin_2: results = "Post Bin 2"; break;
                //case Column.Post_Bin_3: results = "Post Bin 3"; break;
                //case Column.Post_Bin_4: results = "Post Bin 4"; break;
                //case Column.Post_Bin_5: results = "Post Bin 5"; break;
                //case Column.Post_Bin_6: results = "Post Bin 6"; break;
                //case Column.Post_Bin_9: results = "Post Bin 9"; break;
                //case Column.Pre_Bin_1: results = "Pre Bin 1"; break;
                //case Column.Pre_Bin_2: results = "Pre Bin 2"; break;
                //case Column.Pre_Bin_3: results = "Pre Bin 3"; break;
                //case Column.Pre_Bin_4: results = "Pre Bin 4"; break;
                //case Column.Pre_Bin_5: results = "Pre Bin 5"; break;
                //case Column.Pre_Bin_6: results = "Pre Bin 6"; break;
                //case Column.Pre_Bin_9: results = "Pre Bin 9"; break;
                case Column.Process:
                    results = "Process";
                    break;
                //case Column.RPM_verif_Thickness_1: results = "RPM_verif_Thickness_1"; break;
                //case Column.RPM_verif_Thickness_2: results = "RPM_verif_Thickness_2"; break;
                //case Column.RPM_verif_Thickness_3: results = "RPM_verif_Thickness_3"; break;
                //case Column.RPM_verif_Thickness_Average: results = "RPM_verif_Thickness_Average"; break;
                //case Column.RTA_oxide_Thk_Change: results = "RTA oxide Thk Change"; break;
                //case Column.RTA_oxide_post_anneal_Thk: results = "RTA oxide post-anneal Thk"; break;
                //case Column.RTA_oxide_pre_anneal_Thk: results = "RTA oxide pre-anneal Thk"; break;
                case Column.Recipe:
                    results = "Recipe";
                    break;
                //case Column.Resistivity_2_ohm_cm: results = "Resistivity 2 ohm cm"; break; //LEI Weekly Verification
                //case Column.Resistivity_600_ohm_cm: results = "Resistivity 600 ohm cm"; break; //LEI Weekly Verification
                case Column.Rs_verification:
                    results = "Rs verification";
                    break;
                case Column.Rs_verif_100kohm:
                    results = "Rs_verif_100kohm";
                    break;
                case Column.Rs_verif_10ohm:
                    results = "Rs_verif_10ohm";
                    break;
                case Column.Rs_verif_1kohm:
                    results = "Rs_verif_1kohm";
                    break;
                case Column.SID:
                    results = "SID";
                    break;
                case Column.SL_Period_WTAVG:
                    results = "SL Period WTAVG";
                    break;
                case Column.SL_Period:
                    results = "SL Period";
                    break;
                //case Column.SPE_verification: results = "SPE verification"; break;
                //case Column.Sample_ID: results = "Sample ID"; break;
                case Column.Sheet_Concentration:
                    results = "Sheet Concentration";
                    break;
                //case Column.Size: results = "Size"; break;
                //case Column.Small_Adder_Sum: results = "Small Adder Sum"; break;
                //case Column.Spirals_verification: results = "Spirals verification"; break;
                case Column.Time:
                    results = "Time";
                    break;
                case Column.Tool_ID:
                    results = "Tool ID";
                    break;
                //case Column.Total_LPD_Adder: results = "Total LPD Adder"; break;
                //case Column.Total_Verification: results = "Total Verification"; break;
                case Column.Total_Warp_Calibration:
                    results = "Total Warp Calibration";
                    break;
                case Column.UV_Broken:
                    results = "UV Broken";
                    break;
                case Column.UV_Chipping:
                    results = "UV Chipping";
                    break;
                case Column.UV_Cracking_0_3mm_:
                    results = "UV Cracking (0-3mm)";
                    break;
                case Column.UV_Cracking_3_7mm_:
                    results = "UV Cracking (3-7mm)";
                    break;
                case Column.UV_Cracking_7mm_:
                    results = "UV Cracking (>7mm)";
                    break;
                case Column.UV_Crazing:
                    results = "UV Crazing";
                    break;
                case Column.UV_Crazing_Acceptable:
                    results = "UV Crazing Acceptable";
                    break;
                case Column.UV_FULL_Characterization_Wafer:
                    results = "UV FULL Characterization Wafer";
                    break;
                case Column.UV_Haze_count_:
                    results = "UV Haze (count)";
                    break;
                case Column.UV_LIGHT_Characterization_Wafer:
                    results = "UV LIGHT Characterization Wafer";
                    break;
                case Column.UV_Non_rotation:
                    results = "UV Non-rotation";
                    break;
                case Column.UV_Other:
                    results = "UV Other";
                    break;
                case Column.UV_Scratch_count_:
                    results = "UV Scratch (count)";
                    break;
                case Column.UV_Slip_count_:
                    results = "UV Slip (count)";
                    break;
                case Column.UV_True_Haze:
                    results = "UV True Haze";
                    break;
                case Column.UV_True_Haze_Acceptable:
                    results = "UV True Haze Acceptable";
                    break;
                case Column.UV_SPE_1mm_count:
                    results = "UV-SPE (>1mm) count";
                    break;
                case Column.UV_SPE_count_:
                    results = "UV-SPE (count)";
                    break;
                case Column.Verification_Contact_Symmetry:
                    results = "Verification Contact Symmetry";
                    break;
                case Column.Vp_Pinch_Off_Voltage:
                    results = "Vp Pinch Off Voltage";
                    break;
                case Column.Wafer_ID:
                    results = "Wafer ID";
                    break;
                //case Column.Wafer_Pocket: results = "Wafer Pocket"; break;
                case Column.Wafer_Region:
                    results = "Wafer Region";
                    break;
                case Column.Wafer_Scribe:
                    results = "Wafer Scribe";
                    break;
                case Column.WaferPocket_Candela:
                    results = "WaferPocket_Candela";
                    break;
                case Column.WaferPocket_Warp:
                    results = "WaferPocket_Warp";
                    break;
                case Column.WaferPosition_CV:
                    results = "WaferPosition_CV";
                    break;
                case Column.WaferPosition_BV:
                    results = "WaferPosition_BV";
                    break;
                case Column.WaferPosition_Hall:
                    results = "WaferPosition_Hall";
                    break;
                case Column.WaferPosition_PR:
                    results = "WaferPosition_PR";
                    break;
                case Column.Warp:
                    results = "Warp";
                    break;
                case Column.X_Coord:
                    results = "X-Coord";
                    break;
                case Column.XRD_2_Theta_Peak_002:
                    results = "XRD 2 Theta Peak 002";
                    break;
                case Column.XRD_2_Theta_Peak_101:
                    results = "XRD 2 Theta Peak 101";
                    break;
                case Column.XRD_2_Theta_Position:
                    results = "XRD 2-Theta Position";
                    break;
                case Column.XRD_2_Theta_Position_Si_1:
                    results = "XRD 2-Theta Position Si 1";
                    break;
                case Column.XRD_2_Theta_Position_Si_2:
                    results = "XRD 2-Theta Position Si 2";
                    break;
                case Column.XRD_2_Theta_Position_Si_3:
                    results = "XRD 2-Theta Position Si 3";
                    break;
                case Column.XRD_Peak_002_Intensity:
                    results = "XRD Peak 002 Intensity";
                    break;
                case Column.XRD_Peak_101_Intensity:
                    results = "XRD Peak 101 Intensity";
                    break;
                case Column.XRD_Weekly_AL_Center:
                    results = "XRD Weekly AL% Center";
                    break;
                case Column.XRD_Weekly_Back_Barrier_Al_:
                    results = "Back Barrier Al%";
                    break;
                case Column.XRD_Weekly_Barrier_Al_:
                    results = "Barrier Al%";
                    break;
                case Column.XRD_Weekly_FWHM_002:
                    results = "XRD Weekly FWHM 002";
                    break;
                case Column.XRD_Weekly_FWHM_101:
                    results = "XRD Weekly FWHM 101";
                    break;
                case Column.XRD_Weekly_FWHM_105:
                    results = "XRD Weekly FWHM 105";
                    break;
                case Column.XRD_Weekly_Fringe_thick_0_0_:
                    results = "XRD Weekly Fringe thick (0,0)";
                    break;
                case Column.XRD_Weekly_Fringe_thick_48_48_:
                    results = "XRD Weekly Fringe thick (48,48)";
                    break;
                case Column.XRD_Weekly_Intensity:
                    results = "XRD Weekly Intensity";
                    break;
                case Column.XRD_Weekly_Super_Lattice_Al_:
                    results = "Super Lattice Al%";
                    break;
                case Column.XRD_Weekly_Super_Lattice_period:
                    results = "Super Lattice period";
                    break;
                case Column.XRD_Weekly_Super_Lattice_tks:
                    results = "Super Lattice tks";
                    break;
                case Column.XRR_Thickness_nm_WTAVG:
                    results = "XRR Thickness (nm) WTAVG";
                    break;
                case Column.XRR_Thickness_nm_:
                    results = "XRR Thickness (nm)";
                    break;
                case Column.Y_Coord:
                    results = "Y-Coord";
                    break;
                case Column.YellowBand_Power_mW_:
                    results = "YellowBand_Power (mW)";
                    break;
                case Column.YellowBand_V:
                    results = "YellowBand_V";
                    break;
                case Column.YellowBand_V_XY:
                    results = "YellowBand_V_XY";
                    break;
                case Column.YellowBand_nm:
                    results = "YellowBand_nm";
                    break;
                //case Column.pH: results = "pH"; break;
                case Column.Ag:
                    results = "Ag";
                    break;
                case Column.Al:
                    results = "Al";
                    break;
                case Column.As:
                    results = "As";
                    break;
                case Column.Au:
                    results = "Au";
                    break;
                case Column.B:
                    results = "B";
                    break;
                case Column.Ba:
                    results = "Ba";
                    break;
                case Column.Ca:
                    results = "Ca";
                    break;
                case Column.Ce:
                    results = "Ce";
                    break;
                case Column.Co:
                    results = "Co";
                    break;
                case Column.Cr:
                    results = "Cr";
                    break;
                case Column.Cu:
                    results = "Cu";
                    break;
                case Column.Fe:
                    results = "Fe";
                    break;
                case Column.Ga:
                    results = "Ga";
                    break;
                case Column.Ge:
                    results = "Ge";
                    break;
                case Column.Hf:
                    results = "Hf";
                    break;
                case Column.K:
                    results = "K";
                    break;
                case Column.Li:
                    results = "Li";
                    break;
                case Column.Mg:
                    results = "Mg";
                    break;
                case Column.Mn:
                    results = "Mn";
                    break;
                case Column.Mo:
                    results = "Mo";
                    break;
                case Column.Na:
                    results = "Na";
                    break;
                case Column.Ni:
                    results = "Ni";
                    break;
                case Column.P:
                    results = "P";
                    break;
                case Column.Pb:
                    results = "Pb";
                    break;
                case Column.Sn:
                    results = "Sn";
                    break;
                case Column.Ta:
                    results = "Ta";
                    break;
                case Column.Ti:
                    results = "Ti";
                    break;
                case Column.W:
                    results = "W";
                    break;
                case Column.Y:
                    results = "Y";
                    break;
                case Column.Zn:
                    results = "Zn";
                    break;
                default:
                    throw new Exception();
            }
            return results;
        }

        public static Description.Param GetParam(this Column column)
        {
            Description.Param results;
            switch (column)
            {
                //case Column._8in_Total_Warp_Verification: results = Description.Param.String; break;
                //case Column.AFM_Monthly_Y: results = Description.Param.String; break;
                //case Column.AFM_Monthly: results = Description.Param.String; break;
                case Column.AFM_Pit_Count:
                    results = Description.Param.String;
                    break;
                case Column.AFM_Roughness:
                    results = Description.Param.String;
                    break;
                //case Column.Adder_Bin_1: results = Description.Param.String; break;
                //case Column.Adder_Bin_2: results = Description.Param.String; break;
                //case Column.Adder_Bin_3: results = Description.Param.String; break;
                //case Column.Adder_Bin_4: results = Description.Param.String; break;
                //case Column.Adder_Bin_5: results = Description.Param.String; break;
                //case Column.Adder_Bin_6: results = Description.Param.String; break;
                //case Column.Adder_Bin_9: results = Description.Param.String; break;
                case Column.Al_B_B_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.Al_B_B_:
                    results = Description.Param.String;
                    break;
                case Column.Al_Barrier_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.Al_Barrier:
                    results = Description.Param.String;
                    break;
                case Column.Al_SLS_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.Al_SLS:
                    results = Description.Param.String;
                    break;
                case Column.Al_TL1_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.Al_TL1:
                    results = Description.Param.String;
                    break;
                case Column.Al_TL2_WTAVG:
                    results = Description.Param.String;
                    break;
                //case Column.BV_Resistance: results = Description.Param.String; break;
                case Column.BandEdge_V:
                    results = Description.Param.String;
                    break;
                case Column.BandEdge_V_XY:
                    results = Description.Param.String;
                    break;
                case Column.BandEdge_nm:
                    results = Description.Param.String;
                    break;
                case Column.Barrier_Composition_RPM_XY:
                    results = Description.Param.String;
                    break;
                case Column.Bow_Calibration:
                    results = Description.Param.String;
                    break;
                case Column.Bow_Range:
                    results = Description.Param.String;
                    break;
                case Column.Bow:
                    results = Description.Param.String;
                    break;
                case Column.BowCenter:
                    results = Description.Param.String;
                    break;
                case Column.BowX:
                    results = Description.Param.String;
                    break;
                case Column.BowY:
                    results = Description.Param.String;
                    break;
                case Column.Breakdown_Voltage_Edge:
                    results = Description.Param.String;
                    break;
                case Column.Breakdown_VoltageMiddle:
                    results = Description.Param.String;
                    break;
                case Column.Breakdown_Voltage:
                    results = Description.Param.String;
                    break;
                case Column.CV_C_at_10V:
                    results = Description.Param.String;
                    break;
                case Column.CV_Nd_Min:
                    results = Description.Param.String;
                    break;
                //case Column.Candela_Large_LPD_Quarterly: results = Description.Param.String; break;
                //case Column.Candela_Medium_LPD_Quarterly: results = Description.Param.String; break;
                //case Column.Candela_Small_LPD_Quarterly: results = Description.Param.String; break;
                //case Column.Candela_Total_Quarterly: results = Description.Param.String; break;
                case Column.Candela_102_83nm:
                    results = Description.Param.String;
                    break;
                case Column.Candela_1_1um:
                    results = Description.Param.String;
                    break;
                case Column.Candela_496nm:
                    results = Description.Param.String;
                    break;
                case Column.Candela_600nm:
                    results = Description.Param.String;
                    break;
                case Column.Candela_8620_Small:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Crack_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Cracking:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Cracking_Acceptable:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Crater:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Crater_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Haze:
                    results = Description.Param.String;
                    break;
                case Column.Candela_LPD_Large:
                    results = Description.Param.String;
                    break;
                case Column.Candela_LPD_Medium:
                    results = Description.Param.String;
                    break;
                case Column.Candela_LPD_Small:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Large_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Medium_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Pits:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Pits_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_SPE:
                    results = Description.Param.String;
                    break;
                case Column.Candela_SPE_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Slip:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Small_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Spirals:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Spirals_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Total_Defects:
                    results = Description.Param.String;
                    break;
                case Column.Candela_Total_PSL:
                    results = Description.Param.String;
                    break;
                case Column.Candela__1_1um:
                    results = Description.Param.String;
                    break;
                //case Column.Comment: results = Description.Param.String; break;
                //case Column.Conductivity: results = Description.Param.String; break;
                case Column.Contact_Symmetry:
                    results = Description.Param.String;
                    break;
                //case Column.Cracking_verification: results = Description.Param.String; break;
                //case Column.Crater_verification: results = Description.Param.String; break;
                case Column.Date:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Crystal_Life:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Current_AVG:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Current_STDEV:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Deposition_Power_AVG:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Deposition_Power_STDEV:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Deposition_Rate_AVG:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Deposition_Rate_STDEV:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Gun_Pocket:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Pumpdown_Time:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Voltage_AVG:
                    results = Description.Param.String;
                    break;
                case Column.Denton_Voltage_STDEV:
                    results = Description.Param.String;
                    break;
                case Column.Employee:
                    results = Description.Param.String;
                    break;
                case Column.Epi_Thickness_Mean:
                    results = Description.Param.String;
                    break;
                case Column.Epi_Thickness_Mean_XY:
                    results = Description.Param.String;
                    break;
                case Column.Epi_Thickness_Std_Dev_:
                    results = Description.Param.String;
                    break;
                case Column.FWHM_006_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.FWHM_006:
                    results = Description.Param.String;
                    break;
                case Column.FWHM_105_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.FWHM_105:
                    results = Description.Param.String;
                    break;
                case Column.Hall_Rs:
                    results = Description.Param.String;
                    break;
                case Column.Hall_Mobility_verif_sample:
                    results = Description.Param.String;
                    break;
                case Column.Hall_Ns_verif_sample:
                    results = Description.Param.String;
                    break;
                case Column.Hall_Rs_verif_sample:
                    results = Description.Param.String;
                    break;
                case Column.Job:
                    results = Description.Param.String;
                    break;
                case Column.LEI_RS_Average_value:
                    results = Description.Param.String;
                    break;
                case Column.LEI_RS_Maximum_value:
                    results = Description.Param.String;
                    break;
                case Column.LEI_RS_Minimum_value:
                    results = Description.Param.String;
                    break;
                case Column.LEI_RS_STDEV:
                    results = Description.Param.String;
                    break;
                case Column.LEI_RS_STDEV_:
                    results = Description.Param.String;
                    break;
                //case Column.Large_Adder_Sum: results = Description.Param.String; break;
                case Column.Lot:
                    results = Description.Param.String;
                    break;
                //case Column.Medium_Adder_Sum: results = Description.Param.String; break;
                case Column.Microscope_Center_5x:
                    results = Description.Param.String;
                    break;
                case Column.Microscope_Center_50x:
                    results = Description.Param.String;
                    break;
                case Column.Microscope_Middle_5x:
                    results = Description.Param.String;
                    break;
                case Column.Microscope_Middle_50x:
                    results = Description.Param.String;
                    break;
                case Column.Microscope_Edge_5x:
                    results = Description.Param.String;
                    break;
                case Column.Microscope_Edge_50x:
                    results = Description.Param.String;
                    break;
                case Column.Mobility_Verification:
                    results = Description.Param.String;
                    break;
                case Column.Mobility:
                    results = Description.Param.String;
                    break;
                case Column.Ns_Verification:
                    results = Description.Param.String;
                    break;
                case Column.PL_Edge_Wavelength:
                    results = Description.Param.String;
                    break;
                case Column.PL_Ratio:
                    results = Description.Param.String;
                    break;
                case Column.PR_Barrier_Composition:
                    results = Description.Param.String;
                    break;
                case Column.PR_Peak:
                    results = Description.Param.String;
                    break;
                case Column.Part:
                    results = Description.Param.String;
                    break;
                //case Column.Particles_verification: results = Description.Param.String; break;
                //case Column.Pits_verification: results = Description.Param.String; break;
                //case Column.Pocket: results = Description.Param.String; break;
                //case Column.Post_Bin_1: results = Description.Param.String; break;
                //case Column.Post_Bin_2: results = Description.Param.String; break;
                //case Column.Post_Bin_3: results = Description.Param.String; break;
                //case Column.Post_Bin_4: results = Description.Param.String; break;
                //case Column.Post_Bin_5: results = Description.Param.String; break;
                //case Column.Post_Bin_6: results = Description.Param.String; break;
                //case Column.Post_Bin_9: results = Description.Param.String; break;
                //case Column.Pre_Bin_1: results = Description.Param.String; break;
                //case Column.Pre_Bin_2: results = Description.Param.String; break;
                //case Column.Pre_Bin_3: results = Description.Param.String; break;
                //case Column.Pre_Bin_4: results = Description.Param.String; break;
                //case Column.Pre_Bin_5: results = Description.Param.String; break;
                //case Column.Pre_Bin_6: results = Description.Param.String; break;
                //case Column.Pre_Bin_9: results = Description.Param.String; break;
                case Column.Process:
                    results = Description.Param.String;
                    break;
                //case Column.RPM_verif_Thickness_1: results = Description.Param.String; break;
                //case Column.RPM_verif_Thickness_2: results = Description.Param.String; break;
                //case Column.RPM_verif_Thickness_3: results = Description.Param.String; break;
                //case Column.RPM_verif_Thickness_Average: results = Description.Param.String; break;
                //case Column.RTA_oxide_Thk_Change: results = Description.Param.String; break;
                //case Column.RTA_oxide_post_anneal_Thk: results = Description.Param.String; break;
                //case Column.RTA_oxide_pre_anneal_Thk: results = Description.Param.String; break;
                case Column.Recipe:
                    results = Description.Param.String;
                    break;
                //case Column.Resistivity_2_ohm_cm: results = Description.Param.String; break;
                //case Column.Resistivity_600_ohm_cm: results = Description.Param.String; break;
                case Column.Rs_verification:
                    results = Description.Param.String;
                    break;
                case Column.Rs_verif_100kohm:
                    results = Description.Param.String;
                    break;
                case Column.Rs_verif_10ohm:
                    results = Description.Param.String;
                    break;
                case Column.Rs_verif_1kohm:
                    results = Description.Param.String;
                    break;
                case Column.SID:
                    results = Description.Param.String;
                    break;
                case Column.SL_Period_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.SL_Period:
                    results = Description.Param.String;
                    break;
                //case Column.SPE_verification: results = Description.Param.String; break;
                //case Column.Sample_ID: results = Description.Param.String; break;
                case Column.Sheet_Concentration:
                    results = Description.Param.String;
                    break;
                //case Column.Size: results = Description.Param.String; break;
                //case Column.Small_Adder_Sum: results = Description.Param.String; break;
                //case Column.Spirals_verification: results = Description.Param.String; break;
                case Column.Time:
                    results = Description.Param.String;
                    break;
                case Column.Tool_ID:
                    results = Description.Param.String;
                    break;
                //case Column.Total_LPD_Adder: results = Description.Param.String; break;
                //case Column.Total_Verification: results = Description.Param.String; break;
                case Column.Total_Warp_Calibration:
                    results = Description.Param.String;
                    break;
                case Column.UV_Broken:
                    results = Description.Param.String;
                    break;
                case Column.UV_Chipping:
                    results = Description.Param.String;
                    break;
                case Column.UV_Cracking_0_3mm_:
                    results = Description.Param.String;
                    break;
                case Column.UV_Cracking_3_7mm_:
                    results = Description.Param.String;
                    break;
                case Column.UV_Cracking_7mm_:
                    results = Description.Param.String;
                    break;
                case Column.UV_Crazing:
                    results = Description.Param.String;
                    break;
                case Column.UV_Crazing_Acceptable:
                    results = Description.Param.String;
                    break;
                case Column.UV_FULL_Characterization_Wafer:
                    results = Description.Param.String;
                    break;
                case Column.UV_Haze_count_:
                    results = Description.Param.String;
                    break;
                case Column.UV_LIGHT_Characterization_Wafer:
                    results = Description.Param.String;
                    break;
                case Column.UV_Non_rotation:
                    results = Description.Param.String;
                    break;
                case Column.UV_Other:
                    results = Description.Param.String;
                    break;
                case Column.UV_Scratch_count_:
                    results = Description.Param.String;
                    break;
                case Column.UV_Slip_count_:
                    results = Description.Param.String;
                    break;
                case Column.UV_True_Haze:
                    results = Description.Param.String;
                    break;
                case Column.UV_True_Haze_Acceptable:
                    results = Description.Param.String;
                    break;
                case Column.UV_SPE_1mm_count:
                    results = Description.Param.String;
                    break;
                case Column.UV_SPE_count_:
                    results = Description.Param.String;
                    break;
                case Column.Verification_Contact_Symmetry:
                    results = Description.Param.String;
                    break;
                case Column.Vp_Pinch_Off_Voltage:
                    results = Description.Param.String;
                    break;
                case Column.Wafer_ID:
                    results = Description.Param.String;
                    break;
                //case Column.Wafer_Pocket: results = Description.Param.String; break;
                case Column.Wafer_Region:
                    results = Description.Param.String;
                    break;
                case Column.Wafer_Scribe:
                    results = Description.Param.String;
                    break;
                case Column.WaferPocket_Candela:
                    results = Description.Param.String;
                    break;
                case Column.WaferPocket_Warp:
                    results = Description.Param.String;
                    break;
                case Column.WaferPosition_CV:
                    results = Description.Param.String;
                    break;
                case Column.WaferPosition_BV:
                    results = Description.Param.String;
                    break;
                case Column.WaferPosition_Hall:
                    results = Description.Param.String;
                    break;
                case Column.WaferPosition_PR:
                    results = Description.Param.String;
                    break;
                case Column.Warp:
                    results = Description.Param.String;
                    break;
                case Column.X_Coord:
                    results = Description.Param.String;
                    break;
                case Column.XRD_2_Theta_Peak_002:
                    results = Description.Param.String;
                    break;
                case Column.XRD_2_Theta_Peak_101:
                    results = Description.Param.String;
                    break;
                case Column.XRD_2_Theta_Position:
                    results = Description.Param.String;
                    break;
                case Column.XRD_2_Theta_Position_Si_1:
                    results = Description.Param.String;
                    break;
                case Column.XRD_2_Theta_Position_Si_2:
                    results = Description.Param.String;
                    break;
                case Column.XRD_2_Theta_Position_Si_3:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Peak_002_Intensity:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Peak_101_Intensity:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_AL_Center:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Back_Barrier_Al_:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Barrier_Al_:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_FWHM_002:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_FWHM_101:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_FWHM_105:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Fringe_thick_0_0_:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Fringe_thick_48_48_:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Intensity:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Super_Lattice_Al_:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Super_Lattice_period:
                    results = Description.Param.String;
                    break;
                case Column.XRD_Weekly_Super_Lattice_tks:
                    results = Description.Param.String;
                    break;
                case Column.XRR_Thickness_nm_WTAVG:
                    results = Description.Param.String;
                    break;
                case Column.XRR_Thickness_nm_:
                    results = Description.Param.String;
                    break;
                case Column.Y_Coord:
                    results = Description.Param.String;
                    break;
                case Column.YellowBand_Power_mW_:
                    results = Description.Param.String;
                    break;
                case Column.YellowBand_V:
                    results = Description.Param.String;
                    break;
                case Column.YellowBand_V_XY:
                    results = Description.Param.String;
                    break;
                case Column.YellowBand_nm:
                    results = Description.Param.String;
                    break;
                //case Column.pH: results = Description.Param.String; break;
                case Column.Ag:
                    results = Description.Param.String;
                    break;
                case Column.Al:
                    results = Description.Param.String;
                    break;
                case Column.As:
                    results = Description.Param.String;
                    break;
                case Column.Au:
                    results = Description.Param.String;
                    break;
                case Column.B:
                    results = Description.Param.String;
                    break;
                case Column.Ba:
                    results = Description.Param.String;
                    break;
                case Column.Ca:
                    results = Description.Param.String;
                    break;
                case Column.Ce:
                    results = Description.Param.String;
                    break;
                case Column.Co:
                    results = Description.Param.String;
                    break;
                case Column.Cr:
                    results = Description.Param.String;
                    break;
                case Column.Cu:
                    results = Description.Param.String;
                    break;
                case Column.Fe:
                    results = Description.Param.String;
                    break;
                case Column.Ga:
                    results = Description.Param.String;
                    break;
                case Column.Ge:
                    results = Description.Param.String;
                    break;
                case Column.Hf:
                    results = Description.Param.String;
                    break;
                case Column.K:
                    results = Description.Param.String;
                    break;
                case Column.Li:
                    results = Description.Param.String;
                    break;
                case Column.Mg:
                    results = Description.Param.String;
                    break;
                case Column.Mn:
                    results = Description.Param.String;
                    break;
                case Column.Mo:
                    results = Description.Param.String;
                    break;
                case Column.Na:
                    results = Description.Param.String;
                    break;
                case Column.Ni:
                    results = Description.Param.String;
                    break;
                case Column.P:
                    results = Description.Param.String;
                    break;
                case Column.Pb:
                    results = Description.Param.String;
                    break;
                case Column.Sn:
                    results = Description.Param.String;
                    break;
                case Column.Ta:
                    results = Description.Param.String;
                    break;
                case Column.Ti:
                    results = Description.Param.String;
                    break;
                case Column.W:
                    results = Description.Param.String;
                    break;
                case Column.Y:
                    results = Description.Param.String;
                    break;
                case Column.Zn:
                    results = Description.Param.String;
                    break;
                default:
                    throw new Exception();
            }
            return results;
        }

    }

    public enum Column
    {
        //_8in_Total_Warp_Verification,
        //AFM_Monthly_Y,
        //AFM_Monthly,
        AFM_Pit_Count,
        AFM_Roughness,
        //Adder_Bin_1,
        //Adder_Bin_2,
        //Adder_Bin_3,
        //Adder_Bin_4,
        //Adder_Bin_5,
        //Adder_Bin_6,
        //Adder_Bin_9,
        Al_B_B_WTAVG,
        Al_B_B_,
        Al_Barrier_WTAVG,
        Al_Barrier,
        Al_SLS_WTAVG,
        Al_SLS,
        Al_TL1_WTAVG,
        Al_TL1,
        Al_TL2_WTAVG,
        //BV_Resistance,
        BandEdge_V,
        BandEdge_V_XY,
        BandEdge_nm,
        Barrier_Composition_RPM_XY,
        Bow_Calibration,
        Bow_Range,
        Bow,
        BowCenter,
        BowX,
        BowY,
        Breakdown_Voltage_Edge,
        Breakdown_VoltageMiddle,
        Breakdown_Voltage,
        CV_C_at_10V,
        CV_Nd_Min,
        //Candela_Large_LPD_Quarterly,
        //Candela_Medium_LPD_Quarterly,
        //Candela_Small_LPD_Quarterly,
        //Candela_Total_Quarterly,
        Candela_102_83nm,
        Candela_1_1um,
        Candela_496nm,
        Candela_600nm,
        Candela_8620_Small,
        Candela_Crack_Verification,
        Candela_Cracking,
        Candela_Cracking_Acceptable,
        Candela_Crater,
        Candela_Crater_Verification,
        Candela_Haze,
        Candela_LPD_Large,
        Candela_LPD_Medium,
        Candela_LPD_Small,
        Candela_Large_Verification,
        Candela_Medium_Verification,
        Candela_Pits,
        Candela_Pits_Verification,
        Candela_SPE,
        Candela_SPE_Verification,
        Candela_Slip,
        Candela_Small_Verification,
        Candela_Spirals,
        Candela_Spirals_Verification,
        Candela_Total_Defects,
        Candela_Total_PSL,
        Candela__1_1um,
        //Comment,
        //Conductivity,
        Contact_Symmetry,
        //Cracking_verification,
        //Crater_verification,
        Date,
        Denton_Crystal_Life,
        Denton_Current_AVG,
        Denton_Current_STDEV,
        Denton_Deposition_Power_AVG,
        Denton_Deposition_Power_STDEV,
        Denton_Deposition_Rate_AVG,
        Denton_Deposition_Rate_STDEV,
        Denton_Gun_Pocket,
        Denton_Pumpdown_Time,
        Denton_Voltage_AVG,
        Denton_Voltage_STDEV,
        Employee,
        Epi_Thickness_Mean,
        Epi_Thickness_Mean_XY,
        Epi_Thickness_Std_Dev_,
        FWHM_006_WTAVG,
        FWHM_006,
        FWHM_105_WTAVG,
        FWHM_105,
        Hall_Rs,
        Hall_Mobility_verif_sample,
        Hall_Ns_verif_sample,
        Hall_Rs_verif_sample,
        Job,
        LEI_RS_Average_value,
        LEI_RS_Maximum_value,
        LEI_RS_Minimum_value,
        LEI_RS_STDEV,
        LEI_RS_STDEV_,
        //Large_Adder_Sum,
        Lot,
        //Medium_Adder_Sum,
        Microscope_Center_50x,
        Microscope_Center_5x,
        Microscope_Edge_50x,
        Microscope_Edge_5x,
        Microscope_Middle_50x,
        Microscope_Middle_5x,
        Mobility_Verification,
        Mobility,
        Ns_Verification,
        PL_Edge_Wavelength,
        PL_Ratio,
        PR_Barrier_Composition,
        PR_Peak,
        Part,
        //Particles_verification,
        //Pits_verification,
        //Pocket,
        //Post_Bin_1,
        //Post_Bin_2,
        //Post_Bin_3,
        //Post_Bin_4,
        //Post_Bin_5,
        //Post_Bin_6,
        //Post_Bin_9,
        //Pre_Bin_1,
        //Pre_Bin_2,
        //Pre_Bin_3,
        //Pre_Bin_4,
        //Pre_Bin_5,
        //Pre_Bin_6,
        //Pre_Bin_9,
        Process,
        //RPM_verif_Thickness_1,
        //RPM_verif_Thickness_2,
        //RPM_verif_Thickness_3,
        //RPM_verif_Thickness_Average,
        //RTA_oxide_Thk_Change,
        //RTA_oxide_post_anneal_Thk,
        //RTA_oxide_pre_anneal_Thk,
        Recipe,
        //Resistivity_2_ohm_cm,
        //Resistivity_600_ohm_cm,
        Rs_verification,
        Rs_verif_100kohm,
        Rs_verif_10ohm,
        Rs_verif_1kohm,
        SID,
        SL_Period_WTAVG,
        SL_Period,
        //SPE_verification,
        //Sample_ID,
        Sheet_Concentration,
        //Size,
        //Small_Adder_Sum,
        //Spirals_verification,
        Time,
        Tool_ID,
        //Total_LPD_Adder,
        //Total_Verification,
        Total_Warp_Calibration,
        UV_Broken,
        UV_Chipping,
        UV_Cracking_0_3mm_,
        UV_Cracking_3_7mm_,
        UV_Cracking_7mm_,
        UV_Crazing,
        UV_Crazing_Acceptable,
        UV_FULL_Characterization_Wafer,
        UV_Haze_count_,
        UV_LIGHT_Characterization_Wafer,
        UV_Non_rotation,
        UV_Other,
        UV_Scratch_count_,
        UV_Slip_count_,
        UV_True_Haze,
        UV_True_Haze_Acceptable,
        UV_SPE_1mm_count,
        UV_SPE_count_,
        Verification_Contact_Symmetry,
        Vp_Pinch_Off_Voltage,
        Wafer_ID,
        //Wafer_Pocket,
        Wafer_Region,
        Wafer_Scribe,
        WaferPocket_Candela,
        WaferPocket_Warp,
        WaferPosition_CV,
        WaferPosition_BV,
        WaferPosition_Hall,
        WaferPosition_PR,
        Warp,
        X_Coord,
        XRD_2_Theta_Peak_002,
        XRD_2_Theta_Peak_101,
        XRD_2_Theta_Position,
        XRD_2_Theta_Position_Si_1,
        XRD_2_Theta_Position_Si_2,
        XRD_2_Theta_Position_Si_3,
        XRD_Peak_002_Intensity,
        XRD_Peak_101_Intensity,
        XRD_Weekly_AL_Center,
        XRD_Weekly_Back_Barrier_Al_,
        XRD_Weekly_Barrier_Al_,
        XRD_Weekly_FWHM_002,
        XRD_Weekly_FWHM_101,
        XRD_Weekly_FWHM_105,
        XRD_Weekly_Fringe_thick_0_0_,
        XRD_Weekly_Fringe_thick_48_48_,
        XRD_Weekly_Intensity,
        XRD_Weekly_Super_Lattice_Al_,
        XRD_Weekly_Super_Lattice_period,
        XRD_Weekly_Super_Lattice_tks,
        XRR_Thickness_nm_,
        XRR_Thickness_nm_WTAVG,
        Y_Coord,
        YellowBand_Power_mW_,
        YellowBand_V,
        YellowBand_V_XY,
        YellowBand_nm,
        //pH,
        Ag,
        Al,
        As,
        Au,
        B,
        Ba,
        Ca,
        Ce,
        Co,
        Cr,
        Cu,
        Fe,
        Ga,
        Ge,
        Hf,
        K,
        Li,
        Mg,
        Mn,
        Mo,
        Na,
        Ni,
        P,
        Pb,
        Sn,
        Ta,
        Ti,
        W,
        Y,
        Zn
    }

}